/*
 * File generated by SourceCombiner.exe using 20 source files.
 * Created On: 5/14/2022 7:09:55 PM
*/
using MVR.FileManagementSecure;
using Random = System.Random;
using SimpleJSON;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using uFileBrowser;
using UnityEngine;
using UnityEngine.UI;
//*** SourceCombiner -> original file VAM_Decal_Maker.cs ***
namespace VAM_Decal_Maker
{
    public class Decal_Maker : MVRScript
    {
        private const string pluginName = "DecalMaker";
        private const string pluginVersion = "Beta 11";
        //person script is attatched too
        private Atom _parentAtom; //VAM parent
        private Atom _shaderAtom; //Obj holding shader
        private bool _SetupFinished = false;
        private bool _ShadersLoaded = false;
        private bool _SetupError = false;
        private bool _processingCharacterChange = false;
        private Texture[] gpuDecalArray;
        private Texture[] gpuSpecArray;
        private Texture[] gpuGlossArray;
        private Texture[] gpuDiffuseArray;
        private Texture[] gpuNormalArray;
        public DAZCharacter _dazCharacter { get; private set; }
        private DAZCharacterSelector _dazCharacterSelector;
        public Shader _customBulkDecalShader { get; private set; }
        public Shader _customSpecGlossShader { get; private set; }
        public Shader _customNormShader { get; private set; }
        public Shader _customPackedNormShader { get; private set; }
        public Shader _customUINormalMapShader { get; private set; }
        public Shader _customUISpecularMapShader { get; private set; }
        public Shader _customUIGenitalMakerShader { get; private set; }
        public JSONClass _savedData { get; set; }
        public static Dictionary<string, Texture2D> resourceTextures = new Dictionary<string, Texture2D>();
        public DAZMergedSkinV2 _dazSkin { get; private set; }
        //Events
        public Action OnUpDateAction;
        public Action OnDestroyAction;
        //A public event for listeners to subscribe to
        public event EventHandler<PanelEventArgs> CoreEvent;
        //delegate to get saveJSON from DecalManager
        public delegate JSONArray GetJSONSaveDelegate(string MaterialSlot, string TextureSlot);
        public GetJSONSaveDelegate GetJSONDelegate;
        public bool _isMale;
        public string _uvSetName;
        //UI
        public JSONStorableBool _toggleNippleCutout;
        public JSONStorableBool _toggleGenitalCutout;
        private UIDynamicButton _resetButton;
        private UIDynamicButton _saveButton;
        private UIDynamicButton _clearAllButton;
        private UIDynamicButton _prefabButton;
        private UIDynamicButton _savePresetButton;
        private UIDynamicButton _loadPresetButton;
        private UIDynamicToggle _toggleNipple;
        private UIDynamicToggle _toggleGenital;
        private HeaderPanel _headerPanel;
        //GenitalMaker _genitalMakerPanel;
        private bool _Debug = false;
        public void ToggleGensCallBack(bool value)
        {
            OnCoreChange(this, new PanelEventArgs(EventEnum.ToggleGenitalCutout, value));
        }
        public void ToggleNipsCallBack(bool value)
        {
            OnCoreChange(this, new PanelEventArgs(EventEnum.ToggleNippleCutout, value));
        }
        public override void Init()
        {
            try
            {
                if (containingAtom.mainController == null)
                {
                    SuperController.LogError("Please add this plugin to a PERSON atom.");
                    return;
                }
                _parentAtom = containingAtom;
                _parentAtom.mainController.interactableInPlayMode = true;
                //setup all values before finishing UI
                StartCoroutine(CharacterChanged());
                StartCoroutine(CreateAssetAtom("Chokpahi-Asset", "Chokpahi-Asset"));
                _clearAllButton = CreateButton("Clear Everything");
                _prefabButton = CreateButton("USE Prefab", true);
                PrefabPanel prefabPanel = new PrefabPanel(this);
                _resetButton = CreateButton("Reset Texture");
                _saveButton = CreateButton("This Space 4 Rent", true);
                _loadPresetButton = CreateButton("Load Preset");
                _savePresetButton = CreateButton("Save Preset", true);
                _toggleNippleCutout = new JSONStorableBool("Nipple Cutouts ON", true, new JSONStorableBool.SetBoolCallback(ToggleNipsCallBack));
                _toggleNipple = CreateToggle(_toggleNippleCutout);
                _toggleNippleCutout.storeType = JSONStorableParam.StoreType.Full;
                RegisterBool(_toggleNippleCutout);
                _toggleGenitalCutout = new JSONStorableBool("Genital Cutouts ON", true, new JSONStorableBool.SetBoolCallback(ToggleGensCallBack));
                _toggleGenital = CreateToggle(_toggleGenitalCutout, true);
                RegisterBool(_toggleGenitalCutout);
                RegisterBool(_toggleNippleCutout);
                RegisterBool(_toggleGenitalCutout);
                GetBoolJSONParam("Nipple Cutouts ON");
                //assign listners
                _clearAllButton.button.onClick.AddListener(ResetAll);
                _prefabButton.button.onClick.AddListener(prefabPanel.OnClick);
                string presetsPath = "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Presets";
                if (!FileManagerSecure.DirectoryExists(presetsPath))
                {
                    FileManagerSecure.CreateDirectory(presetsPath);
                }
                if (!FileManagerSecure.DirectoryExists(presetsPath + "/PreFabs"))
                {
                    FileManagerSecure.CreateDirectory(presetsPath + "/PreFabs");
                }
                _savePresetButton.button.onClick.AddListener(() =>
                {
                    SuperController.singleton.fileBrowserUI.defaultPath = presetsPath;
                    SuperController.singleton.fileBrowserUI.showFiles = true;
                    SuperController.singleton.fileBrowserUI.showDirs = true;
                    SuperController.singleton.fileBrowserUI.SetTextEntry(true);
                    SuperController.singleton.fileBrowserUI.hideExtension = true;
                    SuperController.singleton.fileBrowserUI.shortCuts = new List<ShortCut>();
                    SuperController.singleton.fileBrowserUI.Show(SavePresetCallback);                  
                });
                _loadPresetButton.button.onClick.AddListener(() =>
                {
                    //Stupid hack to force browserUI to update and show recently saved presets
                    SuperController.singleton.fileBrowserUI.GotoDirectory(presetsPath, null, true);
                    string presets = "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Presets";
                    SuperController.singleton.fileBrowserUI.defaultPath = presets;
                    SuperController.singleton.fileBrowserUI.SetTitle("Select Load Decal Preset");
                    SuperController.singleton.fileBrowserUI.showFiles = true;
                    SuperController.singleton.fileBrowserUI.showDirs = true;
                    SuperController.singleton.fileBrowserUI.SetTextEntry(false);
                    SuperController.singleton.fileBrowserUI.hideExtension = true;
                    List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Presets", false, true, true, false);
                    SuperController.singleton.fileBrowserUI.shortCuts = shortCuts;
                    SuperController.singleton.fileBrowserUI.Show(PresetLoadCallBack);
                });
                //legacy storables some addon may use
                JSONStorableAction resetAllAction = new JSONStorableAction("ClearAll", ResetAll);
                RegisterAction(resetAllAction);
                JSONStorableAction performLoadAction = new JSONStorableAction("PerformLoad", PerformLoad);
                RegisterAction(performLoadAction);
                JSONStorableAction resetTexturesAction = new JSONStorableAction("Reset To Original Textures", ResetOriginalGPUTexturesAction);
                RegisterAction(resetTexturesAction);
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Error during Init" + e);
            }
        }
        public Texture2D GetResource(string path, bool linear = false)
        {
            string cachepath = path + linear.ToString();
            Texture2D texture;
            if (resourceTextures.TryGetValue(cachepath, out texture))
            {
                return texture;
            }
            //not in dictionary
            byte[] tmppng = FileManagerSecure.ReadAllBytes(GetPackagePath(this) + path);
            texture = new Texture2D(1, 1, TextureFormat.RGBA32, linear);
            texture.LoadImage(tmppng);
            resourceTextures.Add(cachepath, texture);
            return texture;
        }
        private void LogError(string err)
        {
            if (_Debug)
            {
                Debug.LogError(err);
            }
        }
        public void DebugSave(Texture2D tempTex, string name)
        {
            //string path = "Custom/PluginData/Chokaphi/VAM_Decal_Maker/" + name;
            //byte[] bytes = tempTex.EncodeToPNG();
            //FileManagerSecure.WriteAllBytes(path, bytes);
        }
        //MacGruber Discord 03/26/2020
        //Get directory path where the plugin is located. Based on Alazi's & VAMDeluxe's method.
        public static string GetPluginPath(MVRScript self)
        {
            string id = self.name.Substring(0, self.name.IndexOf('_'));
            string filename = self.manager.GetJSON()["plugins"][id].Value;
            return filename.Substring(0, filename.LastIndexOfAny(new char[] { '/', '\\' }));
        }
        // Get path prefix of the package that contains our plugin.
        public string GetPackagePath()
        {
            return GetPackagePath(this);
        }
        public static string GetPackagePath(MVRScript self)
        {
            string filename = GetPluginPath(self);
            int idx = filename.IndexOf(":/");
            if (idx >= 0)
                return filename.Substring(0, idx + 2);
            else
                return string.Empty;
        }
        //By: VAMDeluxe Discord
        public List<string> GetFilesAtPathRecursive(string path, string pattern)
        {
            List<string> combined = new List<string>();
            string[] files = FileManagerSecure.GetFiles(path, pattern);
            string[] directories = FileManagerSecure.GetDirectories(path);
            List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory(path);
            files.ToList().ForEach(file =>
            {
                combined.Add(file);
            });
            directories.ToList().ForEach(directory =>
            {
                combined.AddRange(GetFilesAtPathRecursive(directory, pattern));
            });
            return combined;
        }
        //from C# PATH
        private char[] sep = new char[] { '/', '\\' };
        public string GetFileName(string path)
        {
            int num = path.LastIndexOfAny(sep);
            if (num >= 0)
            {
                return path.Substring(num + 1);
            }
            return path;
        }
        //"project-canyon12/05/2018 DISCORD"
        //"I'm going on how I understand Async/Await works in normal C#, but I think the principle is the same"
        //tweaked for my use case
        private delegate void AtomCreatedEvent(Atom atom);
        private IEnumerator CreateAssetAtom(string uniqueAtomName, string nameOfGameObjectToFind)
        {
            //yield return new WaitForSeconds(0.5f);
            Atom createdAtom = GetAtomById(uniqueAtomName);
            if (createdAtom == null)
            {
                yield return SuperController.singleton.AddAtomByType("CustomUnityAsset", uniqueAtomName, true);
                createdAtom = GetAtomById(uniqueAtomName);
            }
            JSONStorable storable = createdAtom.GetStorableByID("asset");
            //should have always had this toggled. Prevents asset from being stored
            storable.exclude = true;
            storable.SetUrlParamValue("assetUrl", GetPackagePath(this) + @"Custom\Assets\Chokaphi\chokpahi-decal.assetbundle");
            storable.SetStringChooserParamValue("assetName", "Assets/Chokpahi-Decal.unity");
            yield return new WaitWhile(() => GameObject.Find(nameOfGameObjectToFind) == null);
            LogError("Asset loaded");
            _shaderAtom = createdAtom;
            LogError("Asset Shader loaded " + createdAtom);
        }
        private void DefineShaders()
        {
            Shader[] renderers = Resources.FindObjectsOfTypeAll<Shader>();
            LogError("Shader setup start. Shaders loaded= " + renderers.Length);
            foreach (Shader shader in renderers)
            {
                if (shader.name == "Custom/Unlit-Specular2")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " Spec-Gloss Shader is " + shader.name);
                    _customSpecGlossShader = shader;
                }
                if (shader.name == "Custom/Unlit-NormalMap2")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " Normal Shader is " + shader.name);
                    _customNormShader = shader;
                }
                if (shader.name == "Custom/Unlit-PackedNormalMap")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " PackedNorm Shader is " + shader.name);
                    _customPackedNormShader = shader;
                }
                if (shader.name == "Custom/Unlit-Decal4")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " BulkShader Shader is " + shader.name);
                    _customBulkDecalShader = shader;
                }
                if (shader.name == "Custom/UI-NormalMapOverlay")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " ui Shader is " + shader.name);
                    _customUINormalMapShader = shader;
                }
                if (shader.name == "Custom/Unlit-GenitalMaker2")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " ui Shader is " + shader.name);
                    _customUIGenitalMakerShader = shader;
                }
            }
            if (_customSpecGlossShader && _customNormShader && _customPackedNormShader && _customBulkDecalShader && _customUINormalMapShader && _customUIGenitalMakerShader)
            {
                _ShadersLoaded = true;
            }
        }
        // Update is called with each rendered frame by Unity
        private void Update()
        {
            try
            {
                if (_SetupError)
                    return;
                //Fire UpdateEvents to subscribers
                if (_SetupFinished == true && OnUpDateAction != null)
                {
                    OnUpDateAction();
                }
                if (_dazCharacter != null && !_processingCharacterChange)
                {
                    if (_dazCharacter != _dazCharacterSelector.selectedCharacter)
                    {
                        _processingCharacterChange = true;
                        LogError("StartCoroutine(CharacterChanged()");
                        StartCoroutine(CharacterChanged());
                    }
                }
                if (_ShadersLoaded == false)
                {
                    LogError("On update call waiting on _customBulkDecalShader");
                    DefineShaders();
                }
                if (_SetupFinished == false && _ShadersLoaded == true)
                {
                    LogError("On update call waiting on SetUp");
                    Setup();
                    LogError("setup should be finished " + _SetupFinished);
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
        public void OnCoreChange(object o, PanelEventArgs e)
        {
            //Fire the event - notifying all subscribers
            if (CoreEvent != null)
                CoreEvent(o, e);
        }
        //called on reload or removal of plugin
        public void OnDestroy()
        {
            ResetOriginalGPUTextures(_dazCharacter);
            if (OnDestroyAction != null)
                OnDestroyAction();
        }
        public void a(string p)
        {
            SuperController.LogError("PATH IS " + p);
        }
        private void Setup()
        {
            try
            {
                //create Header Panel
                _headerPanel = new HeaderPanel(this);
                _resetButton.button.onClick.AddListener(() =>
                {
                    ResetOriginalGPUTextures(_dazCharacter);
                });
                //UIDynamicButton NewPanelButton = CreateButton(" LAST LEFT ELEMENT");
                //JSONStorableUrl url = new JSONStorableUrl("Load p", string.Empty, urlo => a(urlo));
                //NewPanelButton.button.onClick.AddListener(() =>
                //{
                //    SuperController.LogError("SEX b4 " + _isMale + " RP=" + _headerPanel.SelectionPanelDecal.GenitalPanel.renderPanel.IsMale + " np=" +
                //        _headerPanel.SelectionPanelDecal.GenitalPanel.SelfNormRenderPanel.IsMale
                //        );
                //    _isMale = !_isMale;
                //    SuperController.LogError("SEX now " + _isMale + " RP=" + _headerPanel.SelectionPanelDecal.GenitalPanel.renderPanel.IsMale + " np=" +
                //        _headerPanel.SelectionPanelDecal.GenitalPanel.SelfNormRenderPanel.IsMale
                //        );
                //    //url.FileBrowse();
                //});
                //UIDynamicButton UnusedButton2 = CreateButton("LAST RIGHT ELEMENT", true);
                //UnusedButton2.button.onClick.AddListener(() =>
                //{
                //    _parentAtom.tempDisableRender = !_parentAtom.tempDisableRender;
                //    SuperController.singleton.SyncHiddenAtoms();
                //});
                //this is hacky but sets the UI to look nice on start.
                _prefabButton.button.onClick.Invoke();
                _SetupFinished = true;
                OnCoreChange(this, new PanelEventArgs(EventEnum.CoreSetupFinished));
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e.Message);
                SuperController.LogError(e.StackTrace);
                _SetupError = true;
            }
        }
        private void storeGPUMats()
        {
            gpuDecalArray = new Texture[_dazSkin.GPUmaterials.Length];
            gpuSpecArray = new Texture[_dazSkin.GPUmaterials.Length];
            gpuGlossArray = new Texture[_dazSkin.GPUmaterials.Length];
            gpuDiffuseArray = new Texture[_dazSkin.GPUmaterials.Length];
            gpuNormalArray = new Texture[_dazSkin.GPUmaterials.Length];
            for (int i = 0; i < _dazSkin.GPUmaterials.Length; i++)
            {
                if (_dazSkin.GPUmaterials[i].HasProperty(MatSlotEnum.MainTex))
                    gpuDiffuseArray[i] = _dazSkin.GPUmaterials[i].GetTexture(MatSlotEnum.MainTex);
                if (_dazSkin.GPUmaterials[i].HasProperty(MatSlotEnum.DecalTex))
                    gpuDecalArray[i] = _dazSkin.GPUmaterials[i].GetTexture(MatSlotEnum.DecalTex);
                if (_dazSkin.GPUmaterials[i].HasProperty(MatSlotEnum.SpecTex))
                    gpuSpecArray[i] = _dazSkin.GPUmaterials[i].GetTexture(MatSlotEnum.SpecTex);
                if (_dazSkin.GPUmaterials[i].HasProperty(MatSlotEnum.GlossTex))
                    gpuGlossArray[i] = _dazSkin.GPUmaterials[i].GetTexture(MatSlotEnum.GlossTex);
                if (_dazSkin.GPUmaterials[i].HasProperty(MatSlotEnum.BumpMap))
                    gpuNormalArray[i] = _dazSkin.GPUmaterials[i].GetTexture(MatSlotEnum.BumpMap);
            }
        }
        private void restoreGPUMats()
        {   //why not use .GPUmaterials[i] = DazSkinv2.dazMesh.materials[i];
            for (int i = 0; i < _dazSkin.GPUmaterials.Length; i++)
            {
                if (_dazSkin.GPUmaterials[i].HasProperty(MatSlotEnum.MainTex))
                    _dazSkin.GPUmaterials[i].SetTexture(MatSlotEnum.MainTex, gpuDiffuseArray[i]);
                if (_dazSkin.GPUmaterials[i].HasProperty(MatSlotEnum.DecalTex))
                    _dazSkin.GPUmaterials[i].SetTexture(MatSlotEnum.DecalTex, gpuDecalArray[i]);
                if (_dazSkin.GPUmaterials[i].HasProperty(MatSlotEnum.SpecTex))
                    _dazSkin.GPUmaterials[i].SetTexture(MatSlotEnum.SpecTex, gpuSpecArray[i]);
                if (_dazSkin.GPUmaterials[i].HasProperty(MatSlotEnum.GlossTex))
                    _dazSkin.GPUmaterials[i].SetTexture(MatSlotEnum.GlossTex, gpuGlossArray[i]);
                if (_dazSkin.GPUmaterials[i].HasProperty(MatSlotEnum.BumpMap))
                    _dazSkin.GPUmaterials[i].SetTexture(MatSlotEnum.BumpMap, gpuNormalArray[i]);
            }
        }
        public Texture2D GetOriginalGPUTexture(int id, string MaterialSlot)
        {
            switch (MaterialSlot)
            {
                case MatSlotEnum.DecalTex:
                    return (Texture2D)gpuDiffuseArray[id];
                case MatSlotEnum.SpecTex:
                    return (Texture2D)gpuSpecArray[id];
                case MatSlotEnum.GlossTex:
                    return (Texture2D)gpuGlossArray[id];
                case MatSlotEnum.BumpMap:
                    return (Texture2D)gpuNormalArray[id];
            }
            return null;
        }
        public void RestoreGPUMatbyID(int id, string MaterialSlot)
        {
            switch (MaterialSlot)
            {
                case MatSlotEnum.DecalTex:
                    if (_dazSkin.GPUmaterials[id].HasProperty(MatSlotEnum.DecalTex))
                        _dazSkin.GPUmaterials[id].SetTexture(MaterialSlot, gpuDecalArray[id]);
                    break;
                case MatSlotEnum.SpecTex:
                    if (_dazSkin.GPUmaterials[id].HasProperty(MatSlotEnum.SpecTex))
                        _dazSkin.GPUmaterials[id].SetTexture(MaterialSlot, gpuSpecArray[id]);
                    break;
                case MatSlotEnum.GlossTex:
                    if (_dazSkin.GPUmaterials[id].HasProperty(MatSlotEnum.GlossTex))
                        _dazSkin.GPUmaterials[id].SetTexture(MaterialSlot, gpuGlossArray[id]);
                    break;
                case MatSlotEnum.BumpMap:
                    if (_dazSkin.GPUmaterials[id].HasProperty(MatSlotEnum.BumpMap))
                        _dazSkin.GPUmaterials[id].SetTexture(MaterialSlot, gpuNormalArray[id]);
                    break;
            }
        }
        public void QueueCharacterChanged()
        {   
            if (_processingCharacterChange)
            {
                return;
            }
            _processingCharacterChange = true;   
            StartCoroutine(CharacterUpdated(false));
        }
        private IEnumerator CharacterUpdated(bool newCharacter = false)
        {
            if(!newCharacter)
                yield return new WaitForSeconds(1);
            LogError("CharacterUpdated");
            //loadingIcon.gameObject stays true until all texture/cloathing load process is finished
            LogError("yielding till all textures load " + SuperController.singleton.loadingIcon.gameObject.activeSelf);
            yield return new WaitWhile(() => SuperController.singleton.loadingIcon.gameObject.activeSelf);
            LogError("textures load finished continue coroutine");
            //should store the current skin textures.
            LogError("STORE Current Skin Textures");
            storeGPUMats();
            OnCoreChange(this, new PanelEventArgs(EventEnum.CoreNewCharacterSelected, newCharacter));
            _processingCharacterChange = false;
        }
        private IEnumerator CharacterChanged()
        {
            LogError("CharacterChanged");
            //used to know which character is being used or changed
            _dazCharacterSelector = _parentAtom.GetComponentInChildren<DAZCharacterSelector>();
            DAZCharacter previousDazCharacter = _dazCharacter;
            ResetOriginalGPUTextures(previousDazCharacter);
            _dazCharacter = _dazCharacterSelector.selectedCharacter;
            yield return new WaitUntil(() => _dazCharacter.ready);
            _dazSkin = (DAZMergedSkinV2)_dazCharacter.skin;
            _isMale = _dazCharacter.isMale;
            _uvSetName = _dazCharacter.UVname.Replace("UV: ", "");
            LogError("Waiting on UI");
            yield return new WaitUntil(() => _SetupFinished == true);
            LogError("UI should be ready");
            yield return StartCoroutine(CharacterUpdated(true));
            _processingCharacterChange = true;
            if (_savedData != null)
            {
                LogError("Restore save state");
                PerformLoad(_savedData);
                _savedData = null;
            }
            _processingCharacterChange = false;
        }
        //called on character change or UI
        private void ResetOriginalGPUTexturesAction()
        {
            ResetOriginalGPUTextures(_dazCharacter);
        }
        private void ResetOriginalGPUTextures(DAZCharacter dAZCharacter)
        {
            try
            {
                if (dAZCharacter == null || _dazSkin == null)
                    return;
                 restoreGPUMats();
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Error resetting custom textures " + e);
            }
        }
        private void ResetAll()
        {
            ResetOriginalGPUTextures(_dazCharacter);
            OnCoreChange(this, new PanelEventArgs(EventEnum.CoreResetAll));
        }
        private void PresetLoadCallBack(string path)
        {
            PresetLoad(path);
        }
        #region LOAD/SAVE
        public void PresetLoad(string path, bool temp = false, string package = null)
        {
            if (string.IsNullOrEmpty(path))
                return;
            JSONClass jc = this.LoadJSON(path) as JSONClass;
            PerformLoad(jc, temp, package, path);
        }
        private void SavePresetCallback(string path)
        {
            if (string.IsNullOrEmpty(path))
                return;
            JSONClass json = GetJSON();
            path = path.Replace(".dsgn.DecalMakerPreset", "");
            path = path.Replace(".DecalMakerPreset", "");
            path = path + ".DecalMakerPreset.json";
            this.SaveJSON(json, path);
            SuperController.singleton.DoSaveScreenshot(path);
            //SuperController.singleton.fileBrowserUI.ClearCacheImage(path);
        }
        //SAVE
        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
        {
            JSONClass jc = base.GetJSON(includePhysical, includeAppearance, true);
            jc["SaveVersion"] = "2";
            foreach (string matSlot in MatSlotEnum.Values)
            {
                foreach (string region in BodyRegionEnum.Values)
                {
                    //each manager has subscribed to this delegate. Each will only respond when they match the passed arguments
                    //since only the last subscriber gets val return normally. Use a custom invoke to record each 
                    var subs = GetJSONDelegate.GetInvocationList();
                    foreach (var sub in subs)
                    {
                        JSONArray dc = (JSONArray)sub.DynamicInvoke(matSlot, region);
                        if (dc != null)
                        {
                            jc[matSlot][region] = dc;
                        }
                    }
                }
            }
            jc["Nipple Cutouts ON"] = _toggleNippleCutout.val.ToString();
            jc["Genital Cutouts ON"] = _toggleGenitalCutout.val.ToString();
            return jc;
        }
        //LOAD 
        public override void RestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, JSONArray presetAtoms = null, bool setMissingToDefault = true)
        {
            base.RestoreFromJSON(jc, restorePhysical, restoreAppearance, presetAtoms);
            //store and call once we have everything loaded. RestorefromJSON is too early
            _savedData = jc;
        }
        //used for JSONStorableAction
        public void PerformLoad()
        {
            PerformLoad(_savedData);
        }
        private void PerformLoad(JSONClass jc, bool IsTemp = false, string package = null, string selectedFile = null)
        {
            if (jc == null)
                return;
            //convert to new file version if save is old
            try
            {
                if (jc["SaveVersion"] == null)
                    jc = ConvertSaveToV1(jc);
                if (jc["SaveVersion"].AsInt == 1)
                    jc = ConvertSaveToV2(jc);
            }
            catch
            {
                SuperController.LogError("Decal Maker: Unable to convert save");
                return;
            }
            // Load Save Data
            try
            {
                _toggleNippleCutout.RestoreFromJSON(jc);
                _toggleGenitalCutout.RestoreFromJSON(jc);
                foreach (string matSlot in MatSlotEnum.Values)
                {
                    foreach (string region in BodyRegionEnum.Values)
                    {
                        if (jc[matSlot] != null && jc[matSlot][region] != null)
                        {
                            JSONArray array = jc[matSlot][region] as JSONArray;
                            foreach (JSONClass saveJSON in array)
                            {
                                OnCoreChange(this, new PanelEventArgs(EventEnum.CoreRestoreFromJSON, saveJSON) { materialSlot = matSlot, bodyRegion = region, Bool = IsTemp });
                            }
                        }
                    }
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Unable to Load save");
                SuperController.LogError(e.Message);
                SuperController.LogError(e.StackTrace);
                return;
            }
        }
        #endregion
        #region Upgrade Save Version
        //upgrades old saves to new format
        private JSONClass ConvertSaveToV1(JSONClass jc)
        {
            List<string> keys = new List<string>() { BodyRegionEnum.Torso, BodyRegionEnum.Genitals, BodyRegionEnum.Face, BodyRegionEnum.Limbs };
            JSONClass dc = new JSONClass();
            foreach (string key in keys)
            {
                if (jc[key] != null)
                {
                    dc.Add(key, jc[key]);
                }
                jc.Remove(key);
            }
            jc["Decal"] = dc;
            return jc;
        }
        private JSONClass ConvertSaveToV2(JSONClass jc)
        {
            try
            {
                //old keys
                Dictionary<string, string> conversion = new Dictionary<string, string>() { { "Decal", MatSlotEnum.DecalTex }, { "Specular", MatSlotEnum.SpecTex }, { "Gloss", MatSlotEnum.GlossTex }, { "Normal", MatSlotEnum.BumpMap } };
                //SuperController.singleton.SaveJSON(jc, "OUT 1.txt");
                foreach (var keyValue in conversion)
                {
                    JSONClass n = new JSONClass();
                    if (jc[keyValue.Key] != null)
                    {
                        n.Add(keyValue.Value, jc[keyValue.Key]);
                        jc.Remove(keyValue.Key);
                        jc.Add(keyValue.Value, n[keyValue.Value]);
                    }
                }
                jc["SaveVersion"].AsInt = 2;
                return jc;
            }
            catch (Exception e)
            {
                SuperController.LogError("Convert to save version 2 error " + e.Message);
                return null;
            }
        }
    }
    #endregion
}
//*** SourceCombiner -> original file DecalPanel.cs ***
namespace VAM_Decal_Maker
{
    public class DecalPanel : PanelBase
    {
        public ImagePanel ImagePanel { get; set; }
        public MyButton Up { get; private set; }
        public MyButton Down { get; private set; }
        public MyButton Open { get; private set; }
        public MyButton Close { get; private set; }
        public Color Color { get { return ImagePanel.color; } }
        public JSONStorableColor jcolor { get; private set; }
        public UIDynamicSlider sliderDynamic { get; private set; }
        public Action<string> LastDir;
        public event EventHandler<PanelEventArgs> DecalPanelUpdate;
        public string ImagePathText { get { return texturePathTextPanel.text; } set { texturePathTextPanel.text = value; } }
        public string RandomName
        {
            get
            {
                if (randonNameTextPanel == null)
                {
                    return string.Empty;
                }
                return randonNameTextPanel.text;
            }
            set
            {
                if (randonNameTextPanel != null)
                    randonNameTextPanel.text = value;
            }
        }
        private TextPanel texturePathTextPanel;
        private TextPanel randonNameTextPanel;
        private Image panelImage;
        private JSONStorableFloat sliderJSF;
        private float width;
        private float height;
        //event Handler for this class
        private void OnPanelChange(PanelEventArgs e)
        {
            if (DecalPanelUpdate != null)
            {
                DecalPanelUpdate(this, e);
            }
        }
        //events from image panel
        public void ImagePanelEventProcessor(object o, PanelEventArgs e)
        {   //add reference to this panel and pass on. Manager Panel handles operations
            e.DecalPanel = this;
            OnPanelChange(e);
        }
        public override void OnDestroy()
        {
            //ImagePanel.OnDestroy();
            DM.DeregisterFloat(sliderJSF);
            DM.DeregisterColor(jcolor);
            base.OnDestroy();
        }
        public DecalPanel(Transform anchor, float width, float height, Color? color, Decal_Maker DM, string RandomName, string MaterialSlot, string TextureSlot, bool IsNormalMap = false, bool linear = false) : base(DM)
        {
            gameObject.transform.SetParent(anchor, false);
            this.MaterialSlot = MaterialSlot;
            this.TextureSlot = TextureSlot;
            this.IsNormalMap = IsNormalMap;
            this.linear = linear;
            this.width = width;
            this.height = height;
            //basePanel
            panelImage = gameObject.AddComponent<Image>();
            panelImage.material = new Material(Shader.Find("UI/Default-Overlay"));
            panelImage.color = color ?? new Color(0, 0, 0, 0f);
            panelImage.rectTransform.sizeDelta = new Vector2(width, height);
            //Image panel
            GameObject imageObject = new GameObject("ImagePanel");
            imageObject.transform.SetParent(gameObject.transform, false);
            ImagePanel = new ImagePanel(DM, null, TextureSlot, MaterialSlot, IsNormalMap, linear);
            ImagePanel.gameObject.transform.SetParent(gameObject.transform, false);
            ImagePanel.gameObject.transform.localPosition = new Vector3(panelImage.rectTransform.rect.xMax - ImagePanel.rectTransform.rect.xMax - 10, 0, 0);
            //register for event
            ImagePanel.ImagePanelUpdate += ImagePanelEventProcessor;
            //create name and slider
            //must be before text and color selector so it layers properly
            AddSlider(RandomName);
            GameObject colorObject = new GameObject("ColorPanel");
            colorObject.transform.SetParent(gameObject.transform, false);
            colorObject.transform.localScale = new Vector3(.55f, .55f, .55f);
            colorObject.transform.localPosition = new Vector2(-350, 50);
            Image colorImage = colorObject.AddComponent<Image>();
            colorImage.material = new Material(Shader.Find("UI/Default-Overlay"));
            colorImage.color = new Color(0, 1, 1, 0f);
            colorImage.rectTransform.sizeDelta = new Vector2(600, 300);
            colorImage.transform.localPosition = new Vector2(-350, 50);
            Transform colorPickerPrefab = GameObject.Instantiate<Transform>(DM.manager.configurableColorPickerPrefab);
            colorPickerPrefab.SetParent(colorImage.transform, false);
            colorPickerPrefab.localPosition = Vector3.zero;
            UIDynamicColorPicker colorPickerDynamic = colorPickerPrefab.GetComponent<UIDynamicColorPicker>();
            colorPickerDynamic.showLabel = false;
            HSVColor hsvc = HSVColorPicker.RGBToHSV(1f, 1f, 1f);
            jcolor = new JSONStorableColor("Color_" + TextureSlot + MaterialSlot + RandomName, hsvc, ImagePanel.SetColor);
            jcolor.isStorable = false;
            jcolor.colorPicker = colorPickerDynamic.colorPicker;
            DM.RegisterColor(jcolor);
            Up = new MyButton("", new Color(0.9f, 0.6f, 0.1f));
            Up.gameObject.transform.SetParent(gameObject.transform, false);
            Up.gameObject.transform.localPosition = new Vector2(-100, 50);
            RectTransform upRT = Up.gameObject.GetComponent<RectTransform>();
            upRT.sizeDelta = new Vector2(60, 60);
            byte[] tmppng = FileManagerSecure.ReadAllBytes(base.DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/Up-Icon.jpg");
            Texture2D UpIcon = new Texture2D(1, 1, TextureFormat.RGBA32, false);
            UpIcon.LoadImage(tmppng);
            Up.SetIcon(UpIcon);
            Down = new MyButton("", new Color(0.1f, 0.6f, 0.8f));
            Down.gameObject.transform.SetParent(gameObject.transform, false);
            Down.gameObject.transform.localPosition = Up.gameObject.transform.localPosition + new Vector3(65, 0, 0);
            RectTransform dwnRT = Down.gameObject.GetComponent<RectTransform>();
            dwnRT.sizeDelta = new Vector2(60, 60);
            tmppng = FileManagerSecure.ReadAllBytes(base.DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/Down-Icon.jpg");
            Texture2D DownIcon = new Texture2D(1, 1, TextureFormat.RGBA32, false);
            DownIcon.LoadImage(tmppng);
            Down.SetIcon(DownIcon);
            Close = new MyButton("", null, transform);
            //Close.transform.SetParent(transform, false);
            Close.transform.localPosition = Down.transform.localPosition + new Vector3(160, 0, 0);
            RectTransform clsRT = Close.gameObject.GetComponent<RectTransform>();
            clsRT.sizeDelta = new Vector2(60, 60);
            tmppng = FileManagerSecure.ReadAllBytes(base.DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/Close-Icon.jpg");
            Texture2D CloseIcon = new Texture2D(1, 1, TextureFormat.RGBA32, false);
            CloseIcon.LoadImage(tmppng);
            Close.SetIcon(CloseIcon);
            Open = new MyButton("", new Color(.7f, .7f, .7f));
            Open.gameObject.transform.SetParent(gameObject.transform, false);
            Open.gameObject.transform.localPosition = Up.gameObject.transform.localPosition + new Vector3(-65, 0, 0);
            RectTransform opnRT = Open.gameObject.GetComponent<RectTransform>();
            opnRT.sizeDelta = new Vector2(60, 60);
            tmppng = FileManagerSecure.ReadAllBytes(base.DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/Open-Icon.jpg");
            Texture2D OpenIcon = new Texture2D(1, 1, TextureFormat.RGBA32, false);
            OpenIcon.LoadImage(tmppng);
            Open.SetIcon(OpenIcon);
            //Panel Name Text
            randonNameTextPanel = new TextPanel(gameObject, Vector3.zero, "")
            {
                text = RandomName,
                color = new Color(1 - panelImage.color.r, 1 - panelImage.color.g, 1 - panelImage.color.b),
                fontSize = 60,
                fontStyle = FontStyle.Bold,
                alignment = TextAnchor.UpperCenter,
                sizeDelta = new Vector2(width, height),
            };
            //Texture Path Text
            texturePathTextPanel = new TextPanel(gameObject, new Vector2(40, 40), "Path Panel")
            {
                alignment = TextAnchor.LowerLeft,
                color = Color.black,
                fontSize = 30,
                fontStyle = FontStyle.Bold,
                text = "Click White Square to select image.-->",
                blocksRaycasts = false,
                sizeDelta = new Vector2(width, height),
            };
            Up.button.onClick.AddListener(() =>
            {
                OnPanelChange(new PanelEventArgs(EventEnum.DecalPanelButtonUP, this));
            });
            Down.button.onClick.AddListener(() =>
            {
                OnPanelChange(new PanelEventArgs(EventEnum.DecalPanelButtonDOWN, this));
            });
            Close.button.onClick.AddListener(() =>
            {
                OnPanelChange(new PanelEventArgs(EventEnum.DecalPanelButtonCLOSE, this));
            });
            Open.button.onClick.AddListener(() =>
            {
                OnPanelChange(new PanelEventArgs(EventEnum.DecalPanelButtonAdd, this));
            });
        }
        private void AddSlider(string randomName)
        {
            if (IsNormalMap)
            {
                sliderJSF = new JSONStorableFloat(TextureSlot + MaterialSlot + randomName, 1, ImagePanel.SetNormalScale, -10, 10);
                CreateSlider(sliderJSF, -10, 10, 1, "Normal Strength");
            }
            else if (linear)
            {
                sliderJSF = new JSONStorableFloat(TextureSlot + MaterialSlot + randomName, 1, ImagePanel.SetSpecularScale, -10, 10);
                CreateSlider(sliderJSF, -10, 10, 1, "Spec/Gloss Strength").gameObject.SetActive(false);
            }
            else
            {
                sliderJSF = new JSONStorableFloat(TextureSlot + MaterialSlot + randomName, 1, ImagePanel.SetAlpha, 0, 1);
                CreateSlider(sliderJSF, 0, 1, 1, "Alpha value");
            }
            sliderJSF.isStorable = false;
            DM.RegisterFloat(sliderJSF);
        }
        private UIDynamicSlider CreateSlider(JSONStorableFloat action, int min = 0, int max = 1, int value = 1, string title = "")
        {
            Transform sliderPrefab = GameObject.Instantiate<Transform>(DM.manager.configurableSliderPrefab);
            sliderPrefab.SetParent(gameObject.transform, false);
            sliderPrefab.localPosition = Vector3.zero;
            sliderDynamic = sliderPrefab.GetComponent<UIDynamicSlider>();
            sliderDynamic.transform.localPosition = new Vector2(0, -80);
            sliderDynamic.quickButtonsEnabled = false;
            sliderDynamic.rangeAdjustEnabled = false;
            sliderDynamic.defaultButtonEnabled = false;
            Image sliderBackground = sliderDynamic.GetComponentsInChildren<Image>().Where(x => x.name == "Panel").First();
            Color c = sliderBackground.color;
            c.a = 0.1f;
            sliderBackground.color = c;
            action.slider = sliderDynamic.slider;
            //sliderDynamic.slider.onValueChanged.AddListener(action);
            sliderDynamic.slider.minValue = min;
            sliderDynamic.slider.maxValue = max;
            sliderDynamic.slider.value = value;
            sliderDynamic.label = title;
            sliderDynamic.labelText.transform.localPosition += new Vector3(400, 0, 0);
            RectTransform fill = sliderDynamic.slider.fillRect;
            fill.sizeDelta += new Vector2(0, 20);
            return sliderDynamic;
        }
        public void SetPathText(string text)
        {
            //count char back to first slash
            int lastIndex = text.LastIndexOf("/");
            if (text.Length > 55 && lastIndex >= 0)
            {
                string endText = text.Substring(lastIndex);
                int leftover = 55 - endText.Length + 3;
                string startText = text.Substring(0, leftover);
                text = startText + "..." + endText;
            }
            ImagePathText = text;
        }
        //Used to correct paths in JSON to available VAR files until VAM expands FileManagerSecure
        //this is a nasty fucking mess
        //path = image path package
        public void RestoreImageFromJSON(string path, string package = null, string selectedFile = null)
        {
            try
            {
                path = FileManagerSecure.NormalizePath(path);
                Match m;
                //VAR Path for textures with direct var ref
                if ((m = Regex.Match(path, "^(.+\\..+)\\.(.+):/(.+/)(.+)")).Success)
                {
                    //this is a packagedVAR reference use latest version
                    string varName = m.Groups[1].Value;
                    string filePath = m.Groups[3].Value;
                    string fileName = m.Groups[4].Value;
                    ShortCut sc = FileManagerSecure.GetShortCutsForDirectory(filePath).Where(x => x.package.Contains(varName) && x.isLatest).FirstOrDefault();
                    //if nothing found with this path
                    if (sc == null)
                    {
                        SuperController.LogError("Decal Maker: Texture not found: " + path);
                        return;
                    }
                    path = Regex.Replace(sc.path, "^.+/(.+\\..+\\..+)\\..+(:.+)", "$1$2/" + fileName); //removes AddonPackages/ path prefix and the .var from shortcut path
                }
                //if texture and presets are in same VAR  VAM changes all paths to SELF:
                //prefabs UI passes in a package ref
                else if ((m = Regex.Match(path, "^SELF:.+")).Success && package != null)
                {   //SELF:/Custom/Atom/Person/Textures/DecalMaker - mofmes power goo/Face/Cheeks/face04/D.png
                    path = Regex.Replace(path, "^(SELF)(:.+)", package + "$2"); //replace SELF:/ with source package
                }
                else if ((m = Regex.Match(path, "^SELF:.+")).Success && selectedFile != null)
                {
                    if ((m = Regex.Match(selectedFile, "^(.+\\..+\\..+):.+")).Success)
                    {
                        string varName = m.Groups[1].Value;
                        path = Regex.Replace(path, "^(SELF)(:.+)", varName + "$2"); //replace SELF:/ with source package
                    }
                }
                //no fing clue. We have to find it
                else if ((m = Regex.Match(path, "^SELF:.+")).Success)
                {
                    //Find the first package with this path
                    path = Regex.Replace(path, "^SELF:/(.+/)", "$1");
                    string pathWithoutFileName = Regex.Replace(path, "^(.+/).+", "$1");
                    List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory(pathWithoutFileName);
                    foreach (ShortCut s in shortCuts)
                    {
                        if (s.isLatest && s.package != "" && s.package != "AddonPackages Flattened" && s.package != "AddonPackages Filtered")
                        {
                            List<string> files = DM.GetFilesAtPathRecursive(s.path, null);
                            foreach (string f in files)
                            {
                                string t = FileManagerSecure.NormalizePath(f);
                                if (t.Contains(path))
                                {
                                    path = t;
                                    break;
                                }
                            }
                        }
                    }
                }
                BrowserCallBack(path);
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Unable to Resove Texture Path");
                SuperController.LogError(e.InnerException.StackTrace);
            }
        }
        public void BrowserCallBack(string path)
        {
            if (string.IsNullOrEmpty(path))
            {
                SetPathText("");
            }
            else
            {
                SetPathText(path);
                ImagePanel.LoadPNG(path, ImagePanel);
            }
        }
        public JSONClass Save()
        {
            JSONClass decalSaveJSON = new JSONClass();
            decalSaveJSON["H"].AsFloat = jcolor.val.H;
            decalSaveJSON["S"].AsFloat = jcolor.val.S;
            decalSaveJSON["V"].AsFloat = jcolor.val.V;
            decalSaveJSON["Alpha"].AsFloat = ImagePanel.sliderValue;
            decalSaveJSON["RandomName"] = RandomName;
            //SuperController.LogError("ALPHA IS " + ImagePanel.sliderValue);
            //jcolor.StoreJSON(decalSaveJSON, true, true, true);
            if (!string.IsNullOrEmpty(ImagePanel.Path))
            {
                string relativePath = FileManagerSecure.NormalizePath(ImagePanel.Path);
                decalSaveJSON["Path"] = relativePath;
            }
            return decalSaveJSON;
        }
    }
}
//*** SourceCombiner -> original file FakeEnums.cs ***
//lets fake enum since compiler issue
namespace VAM_Decal_Maker
{
    public static class EventEnum
    {
        //Core Panel
        public const string CoreSetupFinished = "Core-SETUP FINISHED";
        public const string CoreTempDecalToPerm = "Core Button:Panel Temp to Perm";
        public const string CoreRemoveTempPanels = "Remove Decals flagged with temp";
        public const string CoreNewCharacterSelected = "New Skin Selected";
        public const string ToggleGenitalCutout = "_toggleGenitalCutout";
        public const string ToggleNippleCutout = "_toggleNippleCutout";
        public const string CoreRestoreFromJSON = "Restore data from json";
        public const string CoreResetAll = "Reset and clear all panels";
        //ImagePanel
        public const string ImagePanelPathChanged = "ImagePanel-PathChange";
        public const string ImagePanelMaterialChanged = "ImagePanel Material Changed";
        public const string ImagePanelNormalSliderChange = "ImagePanel Normal Scale Changed";
        public const string ImagePanelSpecSliderChange = "ImagePanelSpecChanged";
        public const string ImagePanelTextureCleared = "ImagePanelTextureCleared";
        public const string ImagePanelTextureLoaded = "ImagePanelTextureLoaded";
        //DecalPanel
        public const string DecalPanelColor = "Color";
        public const string DecalPanelMove = "DecalPanelMove";
        public const string DecalPanelButtonUP = "DecalPanel-Move-UP";
        public const string DecalPanelButtonDOWN = "DecalPanel-Move-DOWN";
        public const string DecalPanelButtonCLOSE = "DecalPanel Close Button";
        public const string DecalPanelButtonAdd = "DecalPanel-CREATE";
        public const string DecalPanelDELETE = "DecalPanel-DELETE";
        //ManagerPanel
        public const string ManagerPanelSelection = "New Texture Region Selected";
        public const string ManagerPanelRestoreActive = "Restore last active panel";
        //HeaderPanel
        public const string HeaderPanelSelection = "New Material Region Selected";
        //preview Panel
        //public const string Scale = "Scale";
        //public const string Create = "Create";
        //public const string Delete = "Delete";
        //public const string Sort = "Sort";
    }
    public static class MatSlotEnum
    {
        public const string MainTex = "_MainTex";
        public const string DecalTex = "_DecalTex";
        public const string BumpMap = "_BumpMap";
        public const string SpecTex = "_SpecTex";
        public const string GlossTex = "_GlossTex";
        public static readonly List<string> Values = new List<string>() { MainTex, DecalTex, BumpMap, SpecTex, GlossTex };
    }
    public static class BodyRegionEnum
    {
        public const string Torso = "torso";
        public const string Face = "face";
        public const string Limbs = "limbs";
        public const string Genitals = "genitals";
        public static readonly List<string> Values = new List<string>() { Torso, Face, Limbs, Genitals };
    }
}
//*** SourceCombiner -> original file HeaderPanel.cs ***
namespace VAM_Decal_Maker
{
    public class HeaderPanel : UIPanelBase
    {
        public SelectionPanel ActivePanel { get; set; }
        public SelectionPanel SelectionPanelDecal { get; private set; }
        public SelectionPanel SelectionPanelSpec { get; private set; }
        public SelectionPanel SelectionPanelGloss { get; private set; }
        public SelectionPanel SelectionPanelNorm { get; private set; }
        public MyButton decalButton { get; private set; }
        public MyButton specButton { get; private set; }
        public MyButton glossButton { get; private set; }
        public MyButton normButton { get; private set; }
        public MyButton previewButton { get; private set; }
        public Dictionary<string, SelectionPanel> selectionPanels { get; private set; }
        private List<MyButton> buttons;
        //events from Core
        private void CorePanelEvent(object o, PanelEventArgs e)
        {
            switch (e.EventName)
            {
                case EventEnum.HeaderPanelSelection:
                    UpdateSelection(o);
                    break;
                //once setup is finished set Decal as active panel
                case EventEnum.CoreSetupFinished:
                    DM.OnCoreChange(decalButton, new PanelEventArgs(EventEnum.HeaderPanelSelection, SelectionPanelDecal));
                    break;
            }
        }
        private void UpdateSelection(object o)
        {
            if (o.GetType() != typeof(MyButton))
                return;
            foreach (MyButton button in buttons)
            {
                if (button == (MyButton)o)
                {
                    button.Selected(true);
                }
                else
                {
                    button.Selected(false);
                }
            }
        }
        public HeaderPanel(Decal_Maker DM) : base(DM, 50)
        {
            //Image i = spacerLeft.gameObject.AddComponent<Image>();
            //i.material = new Material(Shader.Find("UI/Default-Overlay"));
            //i.material.color = Color.green;
            gameObject.transform.SetParent(spacerLeft.transform, false);
            //center panel in UI
            gameObject.transform.localPosition += new Vector3(270, 10, 0);
            //basePanel
            CreatePanelBackground(1050, 70, new Color(.5f, .5f, .5f, 1));
            SetLayout(200, 50);
            SelectionPanelDecal = new SelectionPanel(1050, 300, new Color(1, 1, 1, 1f), DM)
            {
                MaterialSlot = MatSlotEnum.DecalTex,
                IsNormalMap = false,
                linear = false,
                PanelName = MaterialSlot
            };
            SelectionPanelSpec = new SelectionPanel(1050, 300, new Color(1, 1, 1, 1f), DM)
            {
                MaterialSlot = MatSlotEnum.SpecTex,
                IsNormalMap = false,
                linear = true,
                PanelName = MaterialSlot
            };
            SelectionPanelGloss = new SelectionPanel(1050, 300, new Color(1, 1, 1, 1f), DM)
            {
                MaterialSlot = MatSlotEnum.GlossTex,
                IsNormalMap = false,
                linear = true,
                PanelName = MaterialSlot
            };
            SelectionPanelNorm = new SelectionPanel(1050, 300, new Color(1, 1, 1, 1f), DM)
            {
                MaterialSlot = MatSlotEnum.BumpMap,
                IsNormalMap = true,
                linear = true,
                PanelName = MaterialSlot
            };
            decalButton = new MyButton("Decal", new Color(1, 0.3f, 0.4f), transform);
            decalButton.button.onClick.AddListener(() => DM.OnCoreChange(decalButton, new PanelEventArgs(EventEnum.HeaderPanelSelection, SelectionPanelDecal)));
            specButton = new MyButton("Specular", new Color(0.95f, 0.25f, 0.91f), transform);
            specButton.button.onClick.AddListener(() => DM.OnCoreChange(specButton, new PanelEventArgs(EventEnum.HeaderPanelSelection, SelectionPanelSpec)));
            glossButton = new MyButton("Gloss", new Color(0.2f, .98f, 0.2f), transform);
            glossButton.button.onClick.AddListener(() => DM.OnCoreChange(glossButton, new PanelEventArgs(EventEnum.HeaderPanelSelection, SelectionPanelGloss)));
            normButton = new MyButton("Normal", new Color(0.2f, 0.9f, .9f), transform);
            normButton.button.onClick.AddListener(() => DM.OnCoreChange(normButton, new PanelEventArgs(EventEnum.HeaderPanelSelection, SelectionPanelNorm)));
            buttons = new List<MyButton>() { decalButton, specButton, glossButton, normButton };
            //now finalize panels
            SelectionPanelDecal.CreateManagerPanels();
            SelectionPanelSpec.CreateManagerPanels();
            SelectionPanelGloss.CreateManagerPanels();
            SelectionPanelNorm.CreateManagerPanels();
            SelectionPanelDecal.PanelName = "Decal";
            SelectionPanelSpec.PanelName = "Specular";
            SelectionPanelGloss.PanelName = "Gloss";
            SelectionPanelNorm.PanelName = "Normal";
            ActivePanel = SelectionPanelDecal;
            selectionPanels = new Dictionary<string, SelectionPanel> { { "Decal", SelectionPanelDecal }, { "Specular", SelectionPanelSpec }, { "Gloss", SelectionPanelGloss }, { "Normal", SelectionPanelNorm } };
            DM.CoreEvent += CorePanelEvent;
        }
    }
}
//*** SourceCombiner -> original file ImagePanel.cs ***
namespace VAM_Decal_Maker
{
    public class ImagePanel : ImagePanelBase
    {
        //We now have multiple slider types Alpha and NormalMap so centralize the value
        public float sliderValue { get; private set; } = 1f;
        public bool ImageLoading { get; private set; }
        public string Path { get; set; }
        //isolate image from direct access since imagepanel sometimes modifies the image shader or image so use imagePanels properties not the image's
        public Color color { get; private set; } = Color.white;
        public Texture mainTexture { get { return image.mainTexture; } }
        public Material material { get { return image.material; } }
        public RectTransform rectTransform { get { return image.GetComponent<RectTransform>(); } }
        public event EventHandler<PanelEventArgs> ImagePanelUpdate;
        private void OnImagePanelChange(PanelEventArgs e)
        {
            if (ImagePanelUpdate != null)
            {
                //store a ref to this imagepanel
                e.ImagePanel = this;
                ImagePanelUpdate(this, e);
            }
        }
        public ImagePanel(Decal_Maker DM, Color? color = null, string TextureSlot = null, string MaterialSlot = null, bool IsNormalMap = false, bool linear = false) : base(DM, TextureSlot, MaterialSlot, IsNormalMap, linear)
        {
            base.TextureSlot = TextureSlot;
            base.MaterialSlot = MaterialSlot;
            base.IsNormalMap = IsNormalMap;
            base.linear = linear;
            //image = gameObject.AddComponent<Image>();
            // image.material = new Material(Shader.Find("UI/Default-Overlay"));
            UpdateMaterialColor(color ?? new Color(1, 1, 1, 1f));
            RectTransform imageRect = image.rectTransform;
            imageRect.sizeDelta = new Vector2(300, 300);
            //Button = gameObject.AddComponent<Button>();
            Button.onClick.AddListener(() =>
            {
                OnImagePanelChange(new PanelEventArgs(EventEnum.ImagePanelPathChanged));
            });
        }
        public void SetNormalScale(float value)
        {
            sliderValue = value;
            //SuperController.LogError("_NormalScale " + value + " " + image.material.GetFloat("_NormalScale"));
            Material mat = new Material(DM._customUINormalMapShader);
            mat.SetFloat("_NormalScale", value);
            mat.mainTexture = image.mainTexture;
            GameObject.Destroy(image.material);
            image.material = mat;
            OnImagePanelChange(new PanelEventArgs(EventEnum.ImagePanelNormalSliderChange, mat));
        }
        public void SetSpecularScale(float value)
        {
            sliderValue = value;
            Material mat = new Material(DM._customSpecGlossShader);
            mat.SetFloat("_Smoothness", value);
            mat.mainTexture = image.mainTexture;
            GameObject.Destroy(image.material);
            image.material = mat;
            OnImagePanelChange(new PanelEventArgs(EventEnum.ImagePanelSpecSliderChange, mat));
        }
        public void SetAlpha(float value)
        {
            sliderValue = value;
            Color newAlpha = this.color;// image.material.GetColor("_Color");
            newAlpha.a = value;
            UpdateMaterialColor(newAlpha);
        }
        public void SetColor(JSONStorableColor jcolor)
        {
            Color newColor = jcolor.colorPicker.currentColor;
            //use alpha from slider
            newColor.a = this.color.a;
            UpdateMaterialColor(newColor);
        }
        //cleanup
        public override void OnDestroy()
        {
            //the ones on MainPanel are references to VAM skin.
            GameObject.Destroy(material);
            GameObject.Destroy(mainTexture);
            Resources.UnloadAsset(material);
            Resources.UnloadAsset(mainTexture);
            base.OnDestroy();
        }
        private void UpdateMaterialColor(Color color)
        {
            this.color = color;
            UpdateMaterialColor();
        }
        private void UpdateMaterialColor()
        {
            //The Mask object causes a modified material to be returned so it is no longer rendering the texture that you are updating with the "material" property.
            image.materialForRendering.SetColor("_Color", color);
            //update unmasked material as well
            image.material.SetColor("_Color", color);
            OnImagePanelChange(new PanelEventArgs(EventEnum.DecalPanelColor, color));
        }
        private void UpdateMaterialTexture(Texture2D tex)
        {
            //The Mask object causes a modified material to be returned so it is no longer rendering the texture that you are updating with the "material" property.
            image.materialForRendering.SetTexture("_MainTex", tex);
            //update unmasked material as well
            image.material.SetTexture("_MainTex", tex);
        }
        public void ClearTexture()
        {
            UnityEngine.Object.Destroy(image.material);
            image.material = new Material(Shader.Find("UI/Default-Overlay"));
            OnImagePanelChange(new PanelEventArgs(EventEnum.ImagePanelTextureCleared, material));
        }
        //Use existing texture
        public override void ApplyTexture(Texture2D texture)
        {
            Material material = new Material(Shader.Find("UI/Default-Overlay"));
            material.SetTexture("_MainTex", texture);
            UnityEngine.Object.Destroy(image.material);
            Resources.UnloadAsset(image.material);
            image.material = material;
            image.material.mainTexture = texture;
            OnImagePanelChange(new PanelEventArgs(EventEnum.ImagePanelMaterialChanged, this.material));
        }
        //load texture from disk
        private void OnImageLoaded(ImageLoaderThreaded.QueuedImage qi)
        {
            if (qi != null)
            {
                //create new material instance so we can change texture seperatly
                if (IsNormalMap)
                {
                    image.material = new Material(DM._customUINormalMapShader);
                }
                else
                {
                    image.material = new Material(Shader.Find("UI/Default-Overlay"));
                }
                image.material.mainTexture = qi.tex;
                UpdateMaterialColor();
                Path = qi.imgPath;
                ImageLoading = false;
                OnImagePanelChange(new PanelEventArgs(EventEnum.ImagePanelTextureLoaded, material));
            }
        }
        //Old VAM version does not give access to load texture so use VAM image loading routine instead
        //Newer can use FileManagementSecure.FileManagerSecure or loadTexture
        //Wil call OnImageLoad once finished   
        public void LoadPNG(string filePath, ImagePanel callBack)
        {
            ImageLoaderThreaded.QueuedImage queuedImage = new ImageLoaderThreaded.QueuedImage();
            queuedImage.imgPath = filePath;
            queuedImage.forceReload = false;
            queuedImage.createMipMaps = false;
            queuedImage.isNormalMap = IsNormalMap;
            queuedImage.isThumbnail = false;
            queuedImage.linear = linear;
            queuedImage.createAlphaFromGrayscale = false;
            queuedImage.compress = false;//!queuedImage.isNormalMap;
            queuedImage.callback = new ImageLoaderThreaded.ImageLoaderCallback(callBack.OnImageLoaded); // = new ImageLoaderThreaded.ImageLoaderCallback(OnImageLoaded);
            //start image load
            ImageLoaderThreaded.singleton.QueueImage(queuedImage);
            ImageLoading = true;
        }
    }
}
//*** SourceCombiner -> original file ImagePanelBase.cs ***
namespace VAM_Decal_Maker
{
    public class ImagePanelBase : PanelBase
    {
        protected Image image;
        public Button Button { get; private set; }
        public ImagePanelBase(Decal_Maker DM, string TextureSlot, string MaterialSlot, bool IsNormalMap, bool linear) : base(DM)
        {
            this.MaterialSlot = MaterialSlot;
            this.TextureSlot = TextureSlot;
            this.IsNormalMap = IsNormalMap;
            this.linear = linear;
            image = gameObject.AddComponent<Image>();
            image.material = new Material(Shader.Find("UI/Default-Overlay"));
            Button = gameObject.AddComponent<Button>();
        }
        public override void OnDestroy()
        {
            base.OnDestroy();
        }
        public virtual void ApplyTexture(Texture2D texture)
        {
            image.material.mainTexture = texture;
        }
    }
}
//*** SourceCombiner -> original file ManagerPanel.cs ***
namespace VAM_Decal_Maker
{
    //Controls the display of Decal Level UI elements
    //split off from ImagePanel to focus class
    public class ManagerPanel : UIPanelBase
    {
        public ImagePanelBase ImagePanel { get; set; }
        public new GameObject gameObject { get { return ImagePanel.gameObject; } }
        private Button Button { get { return ImagePanel.Button; } }
        //controls the addition and removal of all panels
        private List<DecalPanel> DecalPanels { get; set; } = new List<DecalPanel>();
        private List<DecalPanel> TempDecalPanels { get; set; } = new List<DecalPanel>();
        private string _lastDir = "Custom/Atom/Person/Textures";
        private static Random rd = new Random();
        private RenderPanelBase renderPanel { get; set; }
        private RenderPanelNormal SelfNormRenderPanel { get; set; }
        private int retries = 0;
        private JSONStorableUrl jsnURL;
        private JSONStorableUrl jsnDecalURL;
        public override void OnDestroy()
        {
            DeregisterDAZCharacterTextureControl();
            base.OnDestroy();
        }
        //events from decal/image panel
        private void DecalPanelEvent(object o, PanelEventArgs e)
        {
            int currentIndex;
            int newIndex;
            if (renderPanel != null)
            {
                switch (e.EventName)
                {
                    case EventEnum.DecalPanelColor:
                        renderPanel.IsDirty = true;
                        break;
                    case EventEnum.DecalPanelMove:
                        RepositionDecalPanel(e.DecalPanel, e.NewPosition);
                        renderPanel.IsDirty = true;
                        break;
                    case EventEnum.DecalPanelButtonUP:
                        currentIndex = e.DecalPanel.gameObject.transform.GetSiblingIndex();
                        newIndex = currentIndex - 1;
                        if (newIndex >= 0)
                        {
                            RepositionDecalPanel(e.DecalPanel, newIndex);
                            renderPanel.IsDirty = true;
                        }
                        break;
                    case EventEnum.DecalPanelButtonDOWN:
                        currentIndex = e.DecalPanel.gameObject.transform.GetSiblingIndex();
                        newIndex = currentIndex + 1;
                        if (newIndex < DecalPanels.Count)
                        {
                            RepositionDecalPanel(e.DecalPanel, newIndex);
                            renderPanel.IsDirty = true;
                        }
                        break;
                    case EventEnum.DecalPanelButtonCLOSE:
                        RemoveDecalPanel(e.DecalPanel);
                        renderPanel.IsDirty = true;
                        break;
                    case EventEnum.DecalPanelButtonAdd:
                        DecalPanel d = AddDecalPanels();
                        currentIndex = e.DecalPanel.gameObject.transform.GetSiblingIndex();
                        newIndex = currentIndex + 1;
                        RepositionDecalPanel(d, newIndex);
                        renderPanel.IsDirty = true;
                        break;
                    case EventEnum.ImagePanelPathChanged:
                        if (_lastDir == null)
                        {
                            _lastDir = "Custom/Atom/Person/Textures";
                        }
                        List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory("Custom/Atom/Person/Textures/", false, true, true, false);
                        SuperController.singleton.GetMediaPathDialog(new FileBrowserCallback(e.DecalPanel.BrowserCallBack), "", _lastDir, true, true, false, null, false, shortCuts);
                        break;
                    case EventEnum.ImagePanelNormalSliderChange:
                        renderPanel.IsDirty = true;
                        break;
                    default:
                        //SuperController.LogError("OPERATION NOT HANDLED" + e.EventName);
                        renderPanel.IsDirty = true;
                        break;
                }
            }
        }
        //events from Core/General events
        public override void CoreEvent(object o, PanelEventArgs e)
        {
            // SuperController.LogError("CORE EVENT " + e.EventName);
            switch (e.EventName)
            {   //set Torso as active slot
                case EventEnum.CoreSetupFinished:
                    if (TextureSlot == BodyRegionEnum.Torso)
                    {
                        DM.OnCoreChange(this, new PanelEventArgs(EventEnum.ManagerPanelSelection, this));
                    }
                    break;
                case EventEnum.CoreTempDecalToPerm:
                    ResetTempDecalPanelTable();
                    break;
                case EventEnum.CoreNewCharacterSelected:
                    if (e.Bool)
                    {
                        //DeregisterDAZCharacterTextureControl();
                        //RegisterDAZCharacterTextureControl();
                    }
                        UpdateSkinImage();
                    renderPanel.IsDirty = true;
                    break;
                case EventEnum.ToggleGenitalCutout:
                    if (MaterialSlot == MatSlotEnum.DecalTex && TextureSlot == BodyRegionEnum.Genitals)
                    {
                        renderPanel.IsDirty = true;
                    }
                    break;
                case EventEnum.ToggleNippleCutout:
                    if (MaterialSlot == MatSlotEnum.DecalTex && TextureSlot == BodyRegionEnum.Torso)
                    {
                        renderPanel.IsDirty = true;
                    }
                    break;
                case EventEnum.ManagerPanelSelection:
                    UpdateSelection(e);
                    break;
                case EventEnum.CoreRestoreFromJSON:
                    if (e.materialSlot == MaterialSlot && e.bodyRegion == TextureSlot)
                    {
                        //SuperController.LogError("EventEnum.CoreRestoreFromJSON:" + MaterialSlot + TextureSlot + " " + DecalPanels.Count);
                        RestorePanelFromJSON(e.saveJSON, e.Bool);
                    }
                    break;
                case EventEnum.CoreResetAll:
                    int count = DecalPanels.Count;
                    for (int i = 0; i < count; i++)
                    {
                        RemoveDecalPanel();
                    }
                    break;
                case EventEnum.CoreRemoveTempPanels:
                    DM.StartCoroutine(RemoveTempDecalPanels());
                    break;
            }
        }
        private void UpdateSelection(PanelEventArgs e)
        {
            //we only want to update on the 4 UI buttons of this material slot.
            if (e.ManagerPanel == this)
            {
                Button.image.color = Color.white;
                ActivateWindow(true);
            }
            else if (e.ManagerPanel.MaterialSlot == MaterialSlot)
            {
                Button.image.color = Color.grey;
                ActivateWindow(false);
            }
        }
        //need to turn our texture and mat enums into VAM equiv strings
        private string ConvertToVAMName(string convert)
        { 
            switch (convert)
            {
                default:
                case MatSlotEnum.DecalTex:
                    return "Decal";
                case MatSlotEnum.MainTex:
                    return "Diffuse";
                case MatSlotEnum.SpecTex:
                    return "Specular";
                case MatSlotEnum.GlossTex:
                    return "Gloss";
                case MatSlotEnum.BumpMap:
                    return "Normal";
                case BodyRegionEnum.Face:
                    return "face";
                case BodyRegionEnum.Limbs:
                    return "limbs";
                case BodyRegionEnum.Torso:
                    return "torso";
                case BodyRegionEnum.Genitals:
                    return "genitals";
            }
        }
        void UrlCallBackDecal(JSONStorableString s)
        {
            SuperController.LogError(DateTime.Now + " UrlCallBackDecal " + MaterialSlot + TextureSlot);
            if (s.val != String.Empty)
            {
                DecalPanel d = AddDecalPanels();
                d.RestoreImageFromJSON(s.val);
            }
        }
        void UrlCallBack(JSONStorableString s)
        {
            SuperController.LogError(DateTime.Now + " UrlCallBack " + MaterialSlot + TextureSlot);
            DM.QueueCharacterChanged();  
        }
        private void RegisterDAZCharacterTextureControl()
        {
            string mat = ConvertToVAMName(MaterialSlot);
            string tex = ConvertToVAMName(TextureSlot);
            string paramName = string.Format("{0}{1}Url", tex, mat);
            DAZCharacterTextureControl dAZCharacterTextureControl = DM._dazCharacter.GetComponentInChildren<DAZCharacterTextureControl>();
            foreach (string UrlParamName in dAZCharacterTextureControl.GetUrlParamNames())
            {
                if (paramName == UrlParamName)
                {
                    JSONStorableUrl jsnURL = dAZCharacterTextureControl.GetUrlJSONParam(UrlParamName);
                    if (MaterialSlot == MatSlotEnum.DecalTex)
                    {   //override VAM Decal system
                        jsnDecalURL = jsnURL;
                        //jsnURL.setJSONCallbackFunction = UrlCallBackDecal;
                        //register diffuse texture change as well
                        //jsnURL = dAZCharacterTextureControl.GetUrlJSONParam(UrlParamName.Replace("Decal", "Diffuse"));
                        //just ask to be notified VAM Decal system
                        //jsnURL.setJSONCallbackFunction += UrlCallBack;
                    }
                    else
                    {//
                     // jsnURL.setJSONCallbackFunction += UrlCallBack;
                    }
                    this.jsnURL = jsnURL;
                }
            }
        }
        private void DeregisterDAZCharacterTextureControl()
        {   if(this.jsnDecalURL != null)
                this.jsnDecalURL.setJSONCallbackFunction -= UrlCallBackDecal;
            if (this.jsnURL != null)
                this.jsnURL.setJSONCallbackFunction -= UrlCallBack;
        }
        private void UpdateSkinImage()
        {
            //System.Diagnostics.Stopwatch watch = System.Diagnostics.Stopwatch.StartNew();
            Texture2D temp = null;
            if (MaterialSlot == MatSlotEnum.DecalTex)
            {
                temp = SelfNormRenderPanel.GetGPUTexture(MatSlotEnum.MainTex, TextureSlot);
            }
            else if (MaterialSlot == MatSlotEnum.BumpMap)
            {   //convert any packed normals to rgb format
                temp = SelfNormRenderPanel.GetGPUTexture(MaterialSlot, TextureSlot);
                if (temp == null)
                    temp = SelfNormRenderPanel.BlankNormalTex;
                temp = SelfNormRenderPanel.ConvertNormal(temp);
            }
            else
            {
                temp = SelfNormRenderPanel.GetGPUTexture(MaterialSlot, TextureSlot);
            }
            ImagePanel.ApplyTexture(temp);
            // watch.Stop();
            //SuperController.LogError(MaterialSlot + " " +TextureSlot + " Skin panel took " + watch.ElapsedMilliseconds);
        }
        public ManagerPanel(Decal_Maker DM = null, Color? color = null, string TextureSlot = null, string MaterialSlot = null, bool IsNormalMap = false, bool linear = false) : base(DM, 300)
        {
            base.MaterialSlot = MaterialSlot;
            base.TextureSlot = TextureSlot;
            base.IsNormalMap = IsNormalMap;
            base.linear = linear;
            DM.GetJSONDelegate += SavePanelToJSON;
            PanelName = MaterialSlot + " " + TextureSlot;
            ImagePanel = new ImagePanelBase(DM, TextureSlot, MaterialSlot, IsNormalMap, linear);
            TextPanel textPanel = new TextPanel(gameObject, new Vector3(0, -35, 0), "Region Text")
            {
                text = TextureSlot.ToUpper() ?? "",
                alignment = TextAnchor.LowerCenter,
                color = new Color(0.196078435f, 0.196078435f, 0.196078435f, 1f),
                fontStyle = FontStyle.Bold,
                fontSize = 30,
                anchorMin = Vector2.zero,
                anchorMax = Vector2.one,
                sizeDelta = Vector2.zero,
            };
            SetLayout(1050, spacerLeft.height);
            RemoveDecalPanel();
            ActivateWindow(false);
            switch (MaterialSlot)
            {
                case MatSlotEnum.DecalTex:
                    renderPanel = new RenderPanelDecal(DM, MaterialSlot, TextureSlot);
                    break;
                case MatSlotEnum.BumpMap:
                    renderPanel = new RenderPanelNormal(DM, MaterialSlot, TextureSlot);
                    break;
                case MatSlotEnum.SpecTex:
                case MatSlotEnum.GlossTex:
                    renderPanel = new RenderPanelSpecGloss(DM, MaterialSlot, TextureSlot);
                    break;
            }
            renderPanel.DecalPanels = DecalPanels;
            DM.CoreEvent += CoreEvent;
            SelfNormRenderPanel = new RenderPanelNormal(base.DM, base.MaterialSlot, base.TextureSlot);
            //reuse button from image panel
            Button.onClick.AddListener(
                () =>
                {
                    DM.OnCoreChange(this, new PanelEventArgs(EventEnum.ManagerPanelSelection, this));
                }
            );
        }
        protected override void SetLayout(float width, float height)
        {
            GridLayoutGroup glg = spacerLeft.gameObject.AddComponent<GridLayoutGroup>();
            glg.cellSize = new Vector2(width, height);
            glg.constraint = GridLayoutGroup.Constraint.FixedColumnCount;
            glg.constraintCount = 1;
            glg.spacing = new Vector2(0, 0);
        }
        private DecalPanel RestorePanelFromJSON(JSONClass saveJSON, bool IsTemp = false)
        {
            string RandomName;
            if (saveJSON["RandomName"] != null)
            {
                RandomName = saveJSON["RandomName"];
                if (DecalPanels.Any(x => x.RandomName == RandomName))
                    RandomName = GeneratePanelName();
            }
            else
            {
                RandomName = GeneratePanelName();
            }
            DecalPanel d = AddDecalPanels(IsTemp, RandomName);
            if (saveJSON["Alpha"] != null)
            {
                d.sliderDynamic.slider.value = (float.Parse(saveJSON["Alpha"]));
            }
            if (saveJSON["H"] != null)
            {
                float h = float.Parse(saveJSON["H"]);
                float s = float.Parse(saveJSON["S"]);
                float v = float.Parse(saveJSON["V"]);
                d.jcolor.SetVal(h, s, v);
            }
            if (saveJSON["Path"] != null)
            {
                d.RestoreImageFromJSON(saveJSON["Path"]);
            }
            d.gameObject.transform.localPosition += new Vector3(270, 0, 0);
            renderPanel.IsDirty = true;
            return d;
        }
        private JSONArray SavePanelToJSON(string MaterialSlot, string TextureSlot)
        {
            if (MaterialSlot == this.MaterialSlot && TextureSlot == this.TextureSlot)
            {
                JSONArray Panel = new JSONArray();
                foreach (DecalPanel d in DecalPanels)
                {
                    JSONClass tempDecal = d.Save();
                    Panel.Add("", tempDecal);
                }
                return Panel;
            }
            return null;
        }
        public DecalPanel AddDecalPanels(bool temp = false, string RandomName = null)
        {
            if (RandomName == null)
                RandomName = GeneratePanelName();
            DecalPanel d = new DecalPanel(spacerLeft.transform, 1050, 300, UnityEngine.Random.ColorHSV(0f, 1f, 1f, 1f, 0.5f, 1f), DM, RandomName, MaterialSlot, TextureSlot, IsNormalMap, linear);
            d.gameObject.transform.localPosition += new Vector3(270, 0, 0);
            IncreaseDecalPanel(d, temp);
            renderPanel.IsDirty = true;
            return d;
        }
        private void IncreaseDecalPanel(DecalPanel d, bool temp = false)
        {
            DecalPanels.Add(d);
            ResizeSpacers(300);
            if (temp)
            {
                TempDecalPanels.Add(d);
            }
            d.DecalPanelUpdate += DecalPanelEvent;
        }
        //unique ID to use for jsonparam
        private string GeneratePanelName()
        {
            DateTime date = DateTime.Now;
            int y = date.Year - 2000;
            int m = date.Month;
            int d = date.Day;
            string randombit = CreateString(3);
            string newName = string.Format("{0}{1}{2}{3}", y, m, d, randombit);
            //regenerate until unique or 100 tries
            if (retries > 100)
            {
                return "FAIL";
            }
            else if (DecalPanels.Any(x => x.RandomName == newName))
            {
                retries++;
                return GeneratePanelName();
            }
            return newName;
        }
        //https://stackoverflow.com/a/4616745 
        internal static string CreateString(int stringLength)
        {
            const string allowedChars = "ABCDEFGHJKLMNOPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz";
            char[] chars = new char[stringLength];
            for (int i = 0; i < stringLength; i++)
            {
                chars[i] = allowedChars[rd.Next(0, allowedChars.Length)];
            }
            return new string(chars);
        }
        public void RemoveDecalPanel()
        {
            if (DecalPanels.Any())
            {
                //get last entry and remove
                DecalPanel d = DecalPanels[DecalPanels.Count - 1];
                RemoveDecalPanel(d);
            }
        }
        public bool RemoveDecalPanel(DecalPanel d)
        {
            bool removed = DecalPanels.Remove(d);
            if (removed)
            {
                d.DecalPanelUpdate -= DecalPanelEvent;
                d.OnDestroy();
                GameObject.Destroy(d.gameObject);
                ResizeSpacers(-300);
                renderPanel.IsDirty = true;
            }
            return true;
        }
        public IEnumerator RemoveTempDecalPanels()
        {
            foreach (DecalPanel d in TempDecalPanels.ToList())
            {
                yield return new WaitUntil(() => RemoveDecalPanel(d));
                RemoveDecalPanel(d);
            }
        }
        public void ResetTempDecalPanelTable()
        {
            TempDecalPanels = new List<DecalPanel>();
        }
        private void RepositionDecalPanel(DecalPanel d, int index)
        {
            d.gameObject.transform.SetSiblingIndex(index);
            DecalPanels.Remove(d);
            DecalPanels.Insert(index, d);
        }
        private void ResizeSpacers(float value)
        {
            spacerLeft.height += value;
            spacerRight.height += value;
        }
        public void ActivateWindow(bool value)
        {
            spacerLeft.gameObject.SetActive(value);
            spacerRight.gameObject.SetActive(value);
        }
    }
}
//*** SourceCombiner -> original file MyButton.cs ***
namespace VAM_Decal_Maker
{
    public class MyButton
    {
        public GameObject gameObject = new GameObject("MyButton");
        public Transform transform { get { return gameObject.transform; } }
        public Image image { get; set; }
        public Button button { get; set; }
        public Text buttonText { get; set; }
        private Color normalColor;
        private Color unselectedColor;
        public void Selected(bool value)
        {
            if (value)
            {
                ColorBlock colors = button.colors;
                colors.normalColor = normalColor;
                button.colors = colors;
            }
            else
            {
                ColorBlock colors = button.colors;
                colors.normalColor = unselectedColor;
                button.colors = colors;
            }
        }
        public MyButton(string label = "Button", Color? color = null, Transform parent = null)
        {
            if(parent != null)
                transform.SetParent(parent,false);
            //transform = gameObject.transform;
            RectTransform rt = gameObject.AddComponent<RectTransform>();
            rt.sizeDelta = new Vector2(160, 30);
            GameObject textGO = new GameObject("Text");
            textGO.transform.SetParent(gameObject.transform, false);
            RectTransform tRT = textGO.AddComponent<RectTransform>();
            tRT.anchorMin = Vector2.zero;
            tRT.anchorMax = Vector2.one;
            tRT.sizeDelta = Vector2.zero;
            buttonText = textGO.AddComponent<Text>();
            buttonText.text = label;
            buttonText.alignment = TextAnchor.MiddleCenter;
            buttonText.color = Color.black;
            buttonText.font = Resources.GetBuiltinResource<Font>("Arial.ttf");
            buttonText.fontSize = 30;
            image = gameObject.AddComponent<Image>();
            image.material = new Material(Shader.Find("UI/Default-Overlay"));
            //image.color = color ?? Color.green;
            normalColor = color ?? new Color(0.6f, 0, 0, 1);
            button = gameObject.AddComponent<Button>();
            //convert color to HSV to allow easier lighten/darken operation
            float H, S, V;
            Color.RGBToHSV(normalColor, out H, out S, out V);
            ColorBlock colors = button.colors;
            colors.highlightedColor = Color.HSVToRGB(H, S, V * 1.4f);
            colors.normalColor = normalColor;
            colors.pressedColor = normalColor;// Color.HSVToRGB(H, S, V * 1.2f);
            unselectedColor = Color.HSVToRGB(H, S, V * 0.5f);
            button.colors = colors;
            Selected(false);
        }
        public void SetIcon(Texture2D icon)
        {
            image.material.mainTexture = icon;
        }
    }
}
//*** SourceCombiner -> original file PanelBase.cs ***
namespace VAM_Decal_Maker
{
    public class PanelBase
    {
        public GameObject gameObject = new GameObject("Panel");
        public Transform transform { get { return gameObject.transform; } }
        protected Decal_Maker DM;
        public string PanelName { get; set; }
        public string TextureSlot { get; set; }
        public string MaterialSlot { get; set; }
        public bool IsNormalMap { get; set; }
        public bool linear { get; set; }
        public virtual void CoreEvent(object o, PanelEventArgs e)
        {
        }
        public PanelBase(Decal_Maker DM)
        {
            this.DM = DM;
            DM.OnUpDateAction += Update;
            DM.OnDestroyAction += OnDestroy;
        }
        protected virtual void Update()
        {
            //if (Input.GetKeyDown("space"))
            //{
            //    SuperController.LogError("PRESSSSSSSS  ");
            //}
        }
        public virtual void OnDestroy()
        {
            DM.OnUpDateAction -= Update;
            DM.OnUpDateAction -= OnDestroy;
        }
        protected void CreatePanelBackground(float width, float height, Color? color)
        {
            //basePanel
            Image panelImage = gameObject.AddComponent<Image>();
            panelImage.material = new Material(Shader.Find("UI/Default-Overlay"));
            panelImage.color = color ?? new Color(.9f, .9f, .9f, 1);
            panelImage.rectTransform.sizeDelta = new Vector2(width, height);
        }
        protected virtual void SetLayout(float width, float height)
        {
            GridLayoutGroup glg = gameObject.AddComponent<GridLayoutGroup>();
            glg.cellSize = new Vector2(width, height);
            glg.constraint = GridLayoutGroup.Constraint.FixedRowCount;
            glg.constraintCount = 1;
            glg.padding = new RectOffset(10, 10, 10, 10);
            glg.spacing = new Vector2(10, 0);
        }
    }
}
//*** SourceCombiner -> original file PanelEventArgs.cs ***
namespace VAM_Decal_Maker
{
    //class that creates a custom eventArgs to be sent with events
    public class PanelEventArgs : EventArgs
    {
        public PanelEventArgs(string EventName)
        {
            this.EventName = EventName;
        }
        public PanelEventArgs(string EventName, bool Value)
        {
            this.EventName = EventName;
            this.Bool = Value;
        }
        public PanelEventArgs(string EventName, string Path)
        {
            this.EventName = EventName;
            this.Path = Path;
        }
        public PanelEventArgs(string EventName, Material Material)
        {
            this.EventName = EventName;
            this.Material = Material;
        }
        public PanelEventArgs(string EventName, Color Color)
        {
            this.EventName = EventName;
            this.Color = Color;
        }
        public PanelEventArgs(string EventName, DecalPanel DecalPanel)
        {
            this.EventName = EventName;
            this.DecalPanel = DecalPanel;
        }
        public PanelEventArgs(string EventName, ManagerPanel ManagerPanel)
        {
            this.EventName = EventName;
            this.ManagerPanel = ManagerPanel;
        }
        public PanelEventArgs(string EventName, SelectionPanel selectionPanel)
        {
            this.EventName = EventName;
            this.SelectionPanel = selectionPanel;
        }
        public PanelEventArgs(string EventName, JSONClass saveJSON)
        {
            this.EventName = EventName;
            this.saveJSON = saveJSON;
        }
        public string materialSlot { get; set; }
        public string bodyRegion { get; set; }
        public JSONClass saveJSON { get; set; }
        public string EventName { get; }
        public Material Material { get; }
        public Color Color { get; }
        public DecalPanel DecalPanel { get; set; }
        public ImagePanel ImagePanel { get; set; }
        public ManagerPanel ManagerPanel { get; set; }
        public HeaderPanel HeaderPanel { get; set; }
        public SelectionPanel SelectionPanel { get; set; }
        public int NewPosition { get; set; }
        public bool Bool { get; set; }
        public string Path { get; set; }
    }
}
//*** SourceCombiner -> original file PrefabCollection.cs ***
namespace VAM_Decal_Maker
{
    public class PrefabCollection
    {
        public string Author { get; private set; }
        public string ItemType { get; private set; }
        public string ItemName { get; private set; }
        public string Path { get; private set; }
        public string Package { get; private set; }
        public string ImagePath { get; private set; }
        public PrefabCollection(string path, string package = null)
        {
            string fileName = GetFileName(path);
            Path = path;
            Package = package;
            MatchCollection mc = Regex.Matches(fileName, "^(.*)_(.*)_(.*).dsgn.DecalMakerPreset.json");
            foreach (Match m in mc)
            {
                Author = m.Groups[1].Value;
                ItemType = m.Groups[2].Value;
                ItemName = m.Groups[3].Value;
                string imagePath = path.Replace(".json", ".jpg");
                if (FileManagerSecure.FileExists(imagePath))
                {
                    ImagePath = imagePath;
                }
            }
        }
        //from C# PATH
        private char[] sep = new char[] { '/', '\\' };
        private string GetFileName(string path)
        {
            int num = path.LastIndexOfAny(sep);
            if (num >= 0)
            {
                return path.Substring(num + 1);
            }
            return path;
        }
    }
}
//*** SourceCombiner -> original file PrefabPanel.cs ***
namespace VAM_Decal_Maker
{
    public class PrefabPanel : UIPanelBase
    {
        private ImagePanel ImagePanel;
        private Dictionary<string, List<PrefabCollection>> prefabFiles = new Dictionary<string, List<PrefabCollection>>();
        private string selectedType;
        private string selectedItem;
        private List<string> author = new List<string>();
        private List<string> prefabTypes = new List<string>();
        private List<string> prefabNames = new List<string>();
        private JSONStorableStringChooser jsc;
        private JSONStorableStringChooser jsc2;
        public PrefabPanel(Decal_Maker DM) : base(DM)
        {
            ImagePanel = new ImagePanel(DM);
            ImagePanel.gameObject.transform.SetParent(spacerRight.transform, false);
            RectTransform imageRect = ImagePanel.rectTransform;
            imageRect.sizeDelta = new Vector2(500, 500);
            GridLayoutGroup glg = spacerLeft.gameObject.AddComponent<GridLayoutGroup>();
            glg.cellSize = new Vector2(500, 100);
            glg.constraint = GridLayoutGroup.Constraint.FixedColumnCount;
            glg.constraintCount = 1;
            glg.padding = new RectOffset(10, 10, 10, 10);
            glg.spacing = new Vector2(10, 0);
            Transform popupPrefabType = GameObject.Instantiate<Transform>(base.DM.manager.configurableScrollablePopupPrefab);
            popupPrefabType.SetParent(spacerLeft.gameObject.transform, false);
            popupPrefabType.localPosition = Vector3.zero;
            UIDynamicPopup dynamicPopupType = popupPrefabType.GetComponent<UIDynamicPopup>();
            dynamicPopupType.name = "CLASS";
            //popupToJSONStorableStringChooser.Add(PrefabType, jsc);
            jsc = new JSONStorableStringChooser("name", prefabTypes, "", "Choose Type");
            jsc.popup = dynamicPopupType.popup;
            Transform popupPrefabItem = GameObject.Instantiate<Transform>(base.DM.manager.configurableScrollablePopupPrefab);
            popupPrefabItem.SetParent(spacerLeft.gameObject.transform, false);
            popupPrefabItem.localPosition = Vector3.zero;
            UIDynamicPopup dynamicPopupItem = popupPrefabItem.GetComponent<UIDynamicPopup>();
            dynamicPopupItem.name = "ITEM";
            dynamicPopupItem.popup.showSlider = false;
            RefreshPrefabCollection();
            jsc2 = new JSONStorableStringChooser("name", prefabNames, "", "Choose Prefab");
            jsc2.popup = dynamicPopupItem.popup;
            dynamicPopupType.popup.onValueChangeUnityEvent.AddListener(TypeValueChanges);
            dynamicPopupItem.popup.onValueChangeUnityEvent.AddListener(ItemValueChanged);
            ImagePanel.Button.onClick.AddListener(() =>
            {
                DM.OnCoreChange(this, new PanelEventArgs(EventEnum.CoreTempDecalToPerm));
            });
            GameObject imageObject = new GameObject("text background");
            imageObject.transform.SetParent(ImagePanel.gameObject.transform, false);
            Image ima = imageObject.AddComponent<Image>();
            ima.color = new Color(.8f, .8f, .8f);
            RectTransform imRT = imageObject.GetComponent<RectTransform>();
            imageObject.transform.localPosition += new Vector3(0, -5f, 0);
            imRT.anchorMin = Vector2.zero;
            imRT.anchorMax = new Vector2(1, 0.1f);
            imRT.sizeDelta = Vector2.zero;
            //Button Text
            GameObject textObject = new GameObject("button text");
            textObject.transform.SetParent(imageObject.gameObject.transform, false);
            //used to prevent text object from blocking clicks
            CanvasGroup cg = textObject.AddComponent<CanvasGroup>();
            cg.blocksRaycasts = false;
            Text panelText = textObject.AddComponent<Text>();
            panelText.alignment = TextAnchor.MiddleCenter;
            panelText.color = Color.black;
            panelText.font = Resources.GetBuiltinResource<Font>("Arial.ttf");
            panelText.fontSize = 30;
            panelText.fontStyle = FontStyle.Bold;
            panelText.text = "Make current Prefab Permanent";
            RectTransform ptRT = panelText.GetComponent<RectTransform>();
            ptRT.anchorMin = new Vector2(0, .02f);
            ptRT.anchorMax = Vector2.one;
            ptRT.sizeDelta = Vector2.zero;
        }
        private void TypeValueChanges(string value)
        {
            selectedType = value;
            RefreshPrefabCollection();
            List<PrefabCollection> a = prefabFiles[value];
            prefabNames = a.Select(x => x.ItemName).ToList();
            prefabNames.Insert(0, "");
            jsc2.SetVal("");
            ResetItem();
            jsc2.choices = prefabNames;
        }
        private void ItemValueChanged(string value)
        {
            selectedItem = value;
            DM.OnCoreChange(this, new PanelEventArgs(EventEnum.CoreRemoveTempPanels));
            if (value == "")
            {
                ResetItem();
            }
            else
            {
                PrefabCollection c = prefabFiles[selectedType].Where(x => x.ItemName == value).FirstOrDefault();
                //reset decals added from other prefabs
                if (c.ImagePath != null)
                    ImagePanel.LoadPNG(c.ImagePath, ImagePanel);
                DM.PresetLoad(c.Path, true, c.Package);
            }
        }
        private void ResetItem()
        {
            DM.OnCoreChange(this, new PanelEventArgs(EventEnum.CoreRemoveTempPanels));
            ImagePanel.ClearTexture();
            DM.PresetLoad(DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/EMPTY.dsgn.DecalMakerPreset.json", true);
        }
        public void RefreshPrefabCollection()
        {
            string path = FileManagerSecure.NormalizePath("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Presets/PreFabs");
            if (!FileManagerSecure.DirectoryExists(path))
                return;
            prefabFiles = new Dictionary<string, List<PrefabCollection>>();
            List<string> files = DM.GetFilesAtPathRecursive(path, null);
            List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory(path);
            foreach (ShortCut s in shortCuts)
            {
                if (s.isLatest && s.package != "" && s.package != "AddonPackages Flattened" && s.package != "AddonPackages Filtered")
                {
                    List<string> temp = DM.GetFilesAtPathRecursive(s.path, null);
                    foreach (string SCFile in temp)
                    {
                        PrefabCollection pc = new PrefabCollection(SCFile, s.package);
                        if (pc.ItemType != null)
                        {
                            if (prefabFiles.ContainsKey(pc.ItemType))
                            {
                                prefabFiles[pc.ItemType].Add(pc);
                            }
                            else
                            {
                                prefabFiles.Add(pc.ItemType, new List<PrefabCollection>() { pc });
                            }
                        }
                    }
                }
            }
            foreach (string file in files)
            {
                PrefabCollection pc = new PrefabCollection(file);
                if (pc.ItemType != null)
                {
                    if (prefabFiles.ContainsKey(pc.ItemType))
                    {
                        prefabFiles[pc.ItemType].Add(pc);
                    }
                    else
                    {
                        prefabFiles.Add(pc.ItemType, new List<PrefabCollection>() { pc });
                    }
                }
            }
            prefabTypes = prefabFiles.Keys.ToList();
            jsc.choices = prefabTypes;
        }
        public void OnClick()
        {
            bool state = !spacerLeft.gameObject.activeSelf;
            spacerLeft.gameObject.SetActive(state);
            spacerRight.gameObject.SetActive(state);
            RefreshPrefabCollection();
        }
    }
}
//*** SourceCombiner -> original file RenderPanelBaseHelpers.cs ***
namespace VAM_Decal_Maker
{
    internal static class RenderPanelBaseHelpers
    {
        private static readonly Dictionary<string, int[]> femaleTextureIndex = new Dictionary<string, int[]>()
        {
            {BodyRegionEnum.Torso, new int[]{15,18,19,20,21,27,29}},
            {BodyRegionEnum.Face, new int[]{2,5,11} },
            {BodyRegionEnum.Limbs, new int[]{0,12,14,16,17,22,23}},
            {BodyRegionEnum.Genitals, new int[]{28}}
        };
        private static readonly Dictionary<string, int[]> maleTextureIndex = new Dictionary<string, int[]>()
        {
            {BodyRegionEnum.Torso, new int[]{15,16,19,20,21,22,30,32}},
            {BodyRegionEnum.Face, new int[]{2,5,11}},
            {BodyRegionEnum.Limbs, new int[]{0,12,14,17,18,23,24}},
            {BodyRegionEnum.Genitals, new int[]{28,29}}
        };
    }
}
//*** SourceCombiner -> original file RenderPanelSpecGloss.cs ***
namespace VAM_Decal_Maker
{
    public class RenderPanelSpecGloss : RenderPanelBase
    {
        private Texture2D _clearTex;
        public RenderPanelSpecGloss(Decal_Maker DM, string MaterialSlot, string TextureSlot) : base(DM, MaterialSlot, TextureSlot)
        {
            material = new Material(DM._customSpecGlossShader);
            _clearTex = DM.GetResource("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/Clear.png", true);
            tempTexture = new Texture2D(4096, 4096, TextureFormat.RGBA32, false, true);
        }
        public override void OnDestroy()
        {
            if (_clearTex != null)
            {
                GameObject.Destroy(_clearTex);
                Resources.UnloadAsset(_clearTex);
            }
            base.OnDestroy();
        }
        public override IEnumerator ApplyChanges()
        {
            if (DecalPanels.Count == 0)
            {
               ResetGPUTexture(MaterialSlot, TextureSlot);
            }
            else
            {
                int count = 0;
                bool multiRender = false;
                ZeroMaterial();
                //if we have a specular material on Base model use it as spec0
                Texture2D mainTex = DM.GetOriginalGPUTexture(_TextureIndex[TextureSlot].FirstOrDefault(), MaterialSlot);
                if (mainTex != null)
                {
                    material.SetVector("_SpecColor" + count, new Vector4(1, 1, 1, 0.5f));
                    material.SetTexture("_SpecTex" + count, mainTex);
                    count = 1;
                }
                foreach (DecalPanel d in DecalPanels)
                {
                    material.SetVector("_SpecColor" + count, new Vector4(1, 1, 1, 0.5f));
                    material.SetTexture("_SpecTex" + count, d.ImagePanel.mainTexture);
                    //material.SetFloat("_Smoothness" +count, d.ImagePanel.sliderValue);
                    count++;
                    //we can bake 10 textures per material
                    if (count > 9)
                    {
                        count = 0;
                        yield return GpuCombine(_clearTex, material, true);
                        ZeroMaterial();
                        multiRender = true;
                    }
                }
                if (multiRender)
                {
                    yield return GpuCombine(tempTexture, material, true);
                }
                else
                {
                    yield return GpuCombine(_clearTex, material, true);
                }
                //apply textures
                SetGPUTexture(tempTexture, MaterialSlot, TextureSlot);
            }
            //Only un-flag IsDirty if no updates happened while processing.
            if (dirtyTimeStart == dirtyTime)
            {
                IsDirty = false;
            }
            Processing = false;
        }
        protected void ZeroMaterial()
        {
            for (int i = 0; i < 10; i++)
            {
                material.SetVector("_SpecColor" + i, new Vector4(1, 1, 1, 0));
                material.SetTexture("_SpecTex" + i, null);
            }
        }
    }
}
//*** SourceCombiner -> original file RenderPanelNormal.cs ***
namespace VAM_Decal_Maker
{
    public class RenderPanelNormal : RenderPanelBase
    {
        private Texture2D _normTex;
        public Texture2D BlankNormalTex { get { return _normTex; } }
        public RenderPanelNormal(Decal_Maker DM, string MaterialSlot, string TextureSlot) : base(DM, MaterialSlot, TextureSlot)
        {
            material = new Material(DM._customNormShader);
            byte[] tmppng = FileManagerSecure.ReadAllBytes(DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/Normal.png");
            _normTex = new Texture2D(1, 1, TextureFormat.RGBA32, false, true);
            _normTex.LoadImage(tmppng);
            tempTexture = new Texture2D(4096, 4096, TextureFormat.RGBA32, false, true);
        }
        public override void OnDestroy()
        {
            if (_normTex != null)
            {
                GameObject.Destroy(_normTex);
                Resources.UnloadAsset(_normTex);
            }
            if (BlankNormalTex != null)
            {
                GameObject.Destroy(BlankNormalTex);
                Resources.UnloadAsset(BlankNormalTex);
            }
            base.OnDestroy();
        }
        //convert normal from packed version for UI button display
        public Texture2D ConvertNormal(Texture2D mainTex)
        {
            material.SetTexture("_BumpMap0", mainTex);
            material.SetFloat("_BumpMapScale0", 1);
            GpuCombine(_normTex, material, true);
            return tempTexture;
        }
        public override IEnumerator ApplyChanges()
        {
            if (DecalPanels.Count == 0)
            {
                ResetGPUTexture(MaterialSlot, TextureSlot);
            }
            else
            {
                int count = 0;
                ZeroMaterial();
                //if we have a normal material on Base model use it as norm0
                Texture2D mainTex = DM.GetOriginalGPUTexture(_TextureIndex[TextureSlot].FirstOrDefault(),  MaterialSlot);
                if (mainTex != null)
                {
                    material.SetTexture("_BumpMap" + count, mainTex);
                    count = 1;
                }
                bool multiRender = false;
                foreach (DecalPanel d in DecalPanels)
                {
                    material.SetFloat("_BumpMapScale" + count, d.ImagePanel.sliderValue);
                    material.SetTexture("_BumpMap" + count, d.ImagePanel.mainTexture);
                    count++;
                    //we can bake 10 textures per material
                    if (count > 9)
                    {
                        count = 0;
                        yield return GpuCombine(_normTex, material, true);
                        ZeroMaterial();
                        multiRender = true;
                    }
                }
                if (multiRender)
                {
                    yield return GpuCombine(tempTexture, material, true);
                }
                else
                {
                    yield return GpuCombine(_normTex, material, true);
                }
                SetGPUTexture(tempTexture, MaterialSlot, TextureSlot);
            }
            //Only un-flag IsDirty if no updates happened while processing.
            if (dirtyTimeStart == dirtyTime)
            {
                IsDirty = false;
            }
            Processing = false;
        }
        //recycle material by setting alphas back to 0
        protected void ZeroMaterial()
        {
            for (int i = 0; i < 10; i++)
            {
                material.SetFloat("_BumpMapScale" + i, 1);
                material.SetTexture("_BumpMap" + i, null);
            }
        }
    }
}
//*** SourceCombiner -> original file RenderPanelDecal.cs ***
namespace VAM_Decal_Maker
{
    public class RenderPanelDecal : RenderPanelBase
    {
        private Texture2D _clearTex;
        public RenderPanelDecal(Decal_Maker DM, string MaterialSlot, string TextureSlot) : base(DM, MaterialSlot, TextureSlot)
        {
            material = new Material(DM._customBulkDecalShader);
            tempTexture = new Texture2D(4096, 4096, TextureFormat.RGBA32, false, false);
            _clearTex = DM.GetResource("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/Clear.png");
        }
        public override void OnDestroy()
        {
            if (_clearTex != null)
            {
                GameObject.Destroy(_clearTex);
                Resources.UnloadAsset(_clearTex);
            }
            base.OnDestroy();
        }
        public override IEnumerator ApplyChanges()
        {
            if (DecalPanels.Count == 0)
            {
                ResetGPUTexture(MaterialSlot, TextureSlot);
            }
            else
            {
                ZeroMaterial();
                //Uses shader to clip part of one texture and applys it to another based on the alpha of a third texture.
                //Used to Apply "Clean" nipples and genital areas after decals have been applied.
                //This Alpha control will be Character UV specific. So Victoria has a diffrent nipple area than Olympia etc..
                if (TextureSlot == BodyRegionEnum.Torso && DM._toggleNippleCutout.val)
                {
                    DM.GetBoolJSONParam("Nipple Cutouts ON");
                    Texture2D alphaTex = DM.GetResource("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/" + DM._uvSetName + ".png");
                    material.SetTexture("_Alpha", alphaTex);
                }
                if (TextureSlot == BodyRegionEnum.Genitals && DM._toggleGenitalCutout.val && IsMale == false)
                {
                    Texture2D alphaTex = DM.GetResource("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/_FemaleGenitals.png");
                    material.SetTexture("_Alpha", alphaTex);
                }
                int count = 0;
                bool linear = false;
                bool multiRender = false;
                foreach (DecalPanel d in DecalPanels)
                {
                    material.SetVector("_DecalColor" + count, d.ImagePanel.color);
                    material.SetTexture("_DecalTex" + count, d.ImagePanel.mainTexture);
                    linear = d.ImagePanel.linear;
                    count++;
                    //we can bake 10 textures per material
                    if (count > 9)
                    {
                        count = 0;
                        yield return GpuCombine(_clearTex, material, linear);
                        ZeroMaterial();
                        multiRender = true;
                    }
                }
                if (multiRender)
                {
                    yield return GpuCombine(tempTexture, material, linear);
                }
                else
                {
                    yield return GpuCombine(_clearTex, material, linear);
                }
                SetGPUTexture(tempTexture, MaterialSlot, TextureSlot);
            }
            //Only un-flag IsDirty if no updates happened while processing.
            if (dirtyTimeStart == dirtyTime)
            {
                IsDirty = false;
            }
            Processing = false;
        }
        //recycle material by setting alphas back to 0
        private void ZeroMaterial()
        {
            material.SetTexture("_Alpha", null);
            for (int i = 0; i < 10; i++)
            {
                material.SetVector("_DecalColor" + i, Color.clear);
                material.SetTexture("_DecalTex" + i, null);
            }
        }
    }
}
//*** SourceCombiner -> original file RenderPanelBase.cs ***
namespace VAM_Decal_Maker
{
    public class RenderPanelBase
    {
        protected Decal_Maker DM;
        protected bool Processing = false;
        protected float dirtyTime = Time.time;
        protected float dirtyTimeStart = Time.time;
        protected Material material;
        protected List<Material> materials = new List<Material>();
        private static readonly Dictionary<string, int[]> femaleTextureIndex = new Dictionary<string, int[]>()
        {
            {BodyRegionEnum.Torso, new int[]{15,18,19,20,21,27,29}},
            {BodyRegionEnum.Face, new int[]{2,5,11} },
            {BodyRegionEnum.Limbs, new int[]{0,12,14,16,17,22,23}},
            {BodyRegionEnum.Genitals, new int[]{28}}
        };
        private static readonly Dictionary<string, int[]> maleTextureIndex = new Dictionary<string, int[]>()
        {
            {BodyRegionEnum.Torso, new int[]{15,16,19,20,21,22,30,32}},
            {BodyRegionEnum.Face, new int[]{2,5,11}},
            {BodyRegionEnum.Limbs, new int[]{0,12,14,17,18,23,24}},
            {BodyRegionEnum.Genitals, new int[]{28,29}}
        };
        public Dictionary<string, int[]> _TextureIndex
        {
            get
            {
                if (IsMale)
                    return maleTextureIndex;
                return femaleTextureIndex;
            }
        }
        public bool IsMale { get { return DM._isMale; } }
        public string TextureSlot { get; protected set; }
        public string MaterialSlot { get; protected set; }
        public List<DecalPanel> DecalPanels { get; set; }
        private bool _isDirty = false;
        public bool IsDirty
        {
            get
            {
                return _isDirty;
            }
            set
            {
                _isDirty = value;
                if (value == true)
                    dirtyTime = Time.time;
            }
        }
        //this is our target texture will alway update referance in all materials it is assigned to 
        protected Texture2D tempTexture { get; set; }
        public RenderPanelBase(Decal_Maker DM, string MaterialSlot, string TextureSlot)
        {
            this.DM = DM;
            DM.OnUpDateAction += Update;
            DM.OnDestroyAction += OnDestroy;
            this.MaterialSlot = MaterialSlot;
            this.TextureSlot = TextureSlot;
        }
        public bool GpuCombine(Texture2D baseTex, Material material, bool linear = false)
        {
            int w = baseTex.width;
            int h = baseTex.height;
            RenderTextureReadWrite renderTexConversion = RenderTextureReadWrite.sRGB;
            if (linear)
            {
                renderTexConversion = RenderTextureReadWrite.Linear;
            }
            RenderTexture tmp = RenderTexture.GetTemporary(w, h, 0, RenderTextureFormat.ARGB32, renderTexConversion);        //tmp.antiAliasing = 8;                                                                                                                           //Backup the currently set RenderTexture
            RenderTexture previous = RenderTexture.active;
            Graphics.Blit(baseTex, tmp, material);
            RenderTexture.active = tmp;
            //tempTexture = new Texture2D(w, h, TextureFormat.RGBA32, false, linear);
            //tempTexture.ReadPixels(new Rect(0, 0, w, h), 0, 0, false);
            //tempTexture.Apply();
            //Avoids GPU to CPU Copy
            Graphics.CopyTexture(tmp, tempTexture);
            // Reset the active RenderTexture
            RenderTexture.active = previous;
            RenderTexture.ReleaseTemporary(tmp);
            return true;
        }
        public void Update()
        {
            //SuperController.LogError("OnLateUpdate()");
            if (IsDirty)
            {
                //SuperController.LogError("IS DIRTY!" + MaterialSlot + " " + TextureSlot);
                if (!Processing)
                {
                    dirtyTimeStart = dirtyTime;
                    Processing = true;
                    DM.StartCoroutine(ApplyChanges());
                }
            }
        }
        public virtual IEnumerator ApplyChanges()
        {
            yield return null;
        }
        public virtual void OnDestroy()
        {
            DM.OnUpDateAction -= Update;
            DM.OnDestroyAction -= OnDestroy;
            //delete materials and texture references
            foreach (Material mat in materials)
            {
                GameObject.Destroy(mat);
                Resources.UnloadAsset(mat);
            }
            if (material != null)
            {
                GameObject.Destroy(material);
                Resources.UnloadAsset(material);
            }
            if (tempTexture != null)
            {
                GameObject.Destroy(tempTexture);
                Resources.UnloadAsset(tempTexture);
            }
        }
        public Texture2D GetGPUTexture(string MaterialSlot, string TextureSlot)
        {
            int num = _TextureIndex[TextureSlot].FirstOrDefault();
            return (Texture2D)DM._dazSkin.GPUmaterials[num].GetTexture(MaterialSlot);
        }
        protected void SetGPUTexture(Texture2D tempTex, string MaterialSlot, string TextureSlot)
        {
            //apply textures
            foreach (int num in _TextureIndex[TextureSlot])
            {
                DM._dazSkin.GPUmaterials[num].SetTexture(MaterialSlot, tempTex);
            }
        }
        protected void ResetGPUTexture(string MaterialSlot, string TextureSlot)
        {
            //reset to default textures
            foreach (int num in _TextureIndex[TextureSlot])
            {
                DM.RestoreGPUMatbyID(num, MaterialSlot);
            }
        }
        //From https://support.unity3d.com/hc/en-us/articles/206486626-How-can-I-get-pixels-from-unreadable-textures-
        //public Texture2D GetUnreadableTexture(Texture2D texture, bool linear = false)
        //{
        //    RenderTextureReadWrite renderTexConversion = RenderTextureReadWrite.sRGB;
        //    if (linear)
        //    {
        //        renderTexConversion = RenderTextureReadWrite.Linear;
        //    }
        //    //LogError("Get Unreadable texture");
        //    RenderTexture tmp = RenderTexture.GetTemporary(texture.width, texture.height, 0, RenderTextureFormat.ARGB32, renderTexConversion);
        //    // Blit the pixels on texture to the RenderTexture
        //    Graphics.Blit(texture, tmp);
        //    // Backup the currently set RenderTexture
        //    RenderTexture previous = RenderTexture.active;
        //    // Set the current RenderTexture to the temporary one we created
        //    RenderTexture.active = tmp;
        //    Texture2D newTexture = TempManager.TempTexture2D(texture.width, texture.height, TextureFormat.RGBA32, false, linear);
        //    newTexture.ReadPixels(new Rect(0, 0, tmp.width, tmp.height), 0, 0);
        //    newTexture.Apply();
        //    // Reset the active RenderTexture
        //    RenderTexture.active = previous;
        //    // Release the temporary RenderTexture
        //    RenderTexture.ReleaseTemporary(tmp);
        //    //LogError("Finish Getting Unreadable texture");
        //    return newTexture;
        //}
    }
}
//*** SourceCombiner -> original file SelectionPanel.cs ***
namespace VAM_Decal_Maker
{
    public class SelectionPanel : UIPanelBase
    {
        private UIDynamicButton AddButton;
        public UIDynamicButton RemoveButton { get; private set; }
        public Dictionary<string, ManagerPanel> ManagerPanels { get; private set; }
        public ManagerPanel ActivePanel { get; private set; }
        public ManagerPanel TorsoPanel { get; private set; }
        public ManagerPanel GenitalPanel { get; private set; }
        public ManagerPanel FacelPanel { get; private set; }
        public ManagerPanel LimbsPanel { get; private set; }
        //events from Core
        private void CorePanelEvent(object o, PanelEventArgs e)
        {
            switch (e.EventName)
            {
                //we have 4 Selection panels each with 4 Manager panels. we only want to update on the 4 UI buttons of this material slot.
                case EventEnum.ManagerPanelSelection:
                    if (e.ManagerPanel.MaterialSlot == MaterialSlot)
                    {
                        ActivePanel = e.ManagerPanel;
                    }
                    break;
                case EventEnum.HeaderPanelSelection:
                    if (e.SelectionPanel == this)
                        ActivateWindow(true);
                    else
                        ActivateWindow(false);
                    break;
            }
        }
        public SelectionPanel(float width, float height, Color? color, Decal_Maker DM) : base(DM, 300)
        {
            //Image i = spacerLeft.gameObject.AddComponent<Image>();
            //i.material = new Material(Shader.Find("UI/Default-Overlay"));
            //i.material.color = Color.blue;
            DM.CoreEvent += CorePanelEvent;
            //create buttons to add/remove panels
            AddButton = DM.CreateButton("Add Image");
            RemoveButton = DM.CreateButton("Remove Image", true);
            gameObject.transform.SetParent(spacerLeft.transform, false);
            gameObject.transform.localPosition += new Vector3(270, 0, 0);
            //basePanel
            CreatePanelBackground(width, height, color);
            SetLayout(250, 250);
            AddButton.button.onClick.AddListener(() => { AddDecalPanel(); });
            RemoveButton.button.onClick.AddListener(RemoveDecalPanel);
            //CreateManagerPanels();
        }
        public void CreateManagerPanels()
        {
            //Torso panel
            TorsoPanel = new ManagerPanel(DM, null, BodyRegionEnum.Torso, MaterialSlot, IsNormalMap, linear);
            TorsoPanel.gameObject.transform.SetParent(gameObject.transform, false);
            //Genital panel
            GenitalPanel = new ManagerPanel(DM, null, BodyRegionEnum.Genitals, MaterialSlot, IsNormalMap, linear);
            GenitalPanel.gameObject.transform.SetParent(gameObject.transform, false);
            //Face panel
            FacelPanel = new ManagerPanel(DM, null, BodyRegionEnum.Face, MaterialSlot, IsNormalMap, linear);
            FacelPanel.gameObject.transform.SetParent(gameObject.transform, false);
            //Limbs panel
            LimbsPanel = new ManagerPanel(DM, null, BodyRegionEnum.Limbs, MaterialSlot, IsNormalMap, linear);
            LimbsPanel.gameObject.transform.SetParent(gameObject.transform, false);
            ActivePanel = TorsoPanel;
            ManagerPanels = new Dictionary<string, ManagerPanel>() { { BodyRegionEnum.Torso, TorsoPanel }, { BodyRegionEnum.Genitals, GenitalPanel }, { BodyRegionEnum.Face, FacelPanel }, { BodyRegionEnum.Limbs, LimbsPanel } };
        }
        public void ActivateWindow(bool value)
        {
            spacerLeft.gameObject.SetActive(value);
            spacerRight.gameObject.SetActive(value);
            AddButton.gameObject.SetActive(value);
            RemoveButton.gameObject.SetActive(value);
            ActivePanel.ActivateWindow(value);
        }
        public DecalPanel AddDecalPanel()
        {
            DecalPanel d = ActivePanel.AddDecalPanels();
            return d;
        }
        public void RemoveDecalPanel()
        {
            ActivePanel.RemoveDecalPanel();
        }
    }
}
//*** SourceCombiner -> original file TextPanel.cs ***
namespace VAM_Decal_Maker
{
    //create text gameobjects
    public class TextPanel
    {
        public string text { get { return TextObject.text; } set { TextObject.text = value; } }
        public TextAnchor alignment { get { return TextObject.alignment; } set { TextObject.alignment = value; } }
        public Color color { get { return TextObject.color; } set { TextObject.color = value; } }
        public Font font { get { return TextObject.font; } set { TextObject.font = value; } }
        public FontStyle fontStyle { get { return TextObject.fontStyle; } set { TextObject.fontStyle = value; } }
        public int fontSize { get { return TextObject.fontSize; } set { TextObject.fontSize = value; } }
        public RectTransform rectTransform { get; }
        public Vector2 anchorMin { get { return rectTransform.anchorMin; } set { rectTransform.anchorMin = value; } }
        public Vector2 anchorMax { get { return rectTransform.anchorMax; } set { rectTransform.anchorMax = value; } }
        public Vector2 sizeDelta { get { return rectTransform.sizeDelta; } set { rectTransform.sizeDelta = value; } }
        //used to prevent text object from blocking clicks
        public bool blocksRaycasts { get; set; }
        private GameObject gameObject;
        private CanvasGroup canvasGroup;
        private Text TextObject;
        public TextPanel(GameObject parentObject, Vector3 localPosition, string description = null)
        {
            gameObject = new GameObject(description);
            rectTransform = gameObject.AddComponent<RectTransform>();
            gameObject.transform.SetParent(parentObject.transform, false);
            if (localPosition != null)
                gameObject.transform.localPosition = localPosition;
            TextObject = gameObject.AddComponent<Text>();
            font = Resources.GetBuiltinResource<Font>("Arial.ttf");
            canvasGroup = gameObject.AddComponent<CanvasGroup>();
            canvasGroup.blocksRaycasts = false;
        }
    }
}
//*** SourceCombiner -> original file UIPanelBase.cs ***
namespace VAM_Decal_Maker
{
    //root class that provide the basic setup and anchor for a window
    //fix this to derive
    public class UIPanelBase : PanelBase
    {
        protected UIDynamic spacerLeft { get; set; }
        protected UIDynamic spacerRight { get; set; }
        public UIPanelBase(Decal_Maker DM, int size = 550) : base(DM)
        {
            //create a UI Spacers to Hold our Panels
            spacerLeft = DM.CreateSpacer(false);
            spacerLeft.height = size;
            spacerRight = DM.CreateSpacer(true);
            spacerRight.height = size;
        }
    }
}
